/* C code startup routine.
   Copyright (C) 1985, 1986, 1992 Free Software Foundation, Inc.

This file is part of GNU Emacs.

GNU Emacs is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU Emacs is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Emacs; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */


/* The standard Vax 4.2 Unix crt0.c cannot be used for Emacs
   because it makes `envron' an initialized variable.
   It is easiest to have a special crt0.c on all machines
   though I don't know whether other machines actually need it.  */

/* On the vax and 68000, in BSD4.2 and USG5.2,
   this is the data format on startup:
  (vax) ap and fp are unpredictable as far as I know; don't use them.
  sp ->  word containing argc
         word pointing to first arg string
	 [word pointing to next arg string]... 0 or more times
	 0
Optionally:
	 [word pointing to environment variable]... 1 or more times
	 ...
	 0
And always:
	 first arg string
	 [next arg string]... 0 or more times
*/

/* On the 16000, at least in the one 4.2 system I know about,
  the initial data format is
  sp ->  word containing argc
         word containing argp
         word pointing to first arg string, and so on as above
*/

#ifdef MSDOS  /* 96.3.17  by K.Fujii */
/* Copyright (C) 1995 DJ Delorie, see COPYING.DJ for details */
/*****************************************************************************
 * Interface to 32-bit executable (from stub.asm)
 *
 *   cs:eip	according to COFF header
 *   ds		32-bit data segment for COFF program
 *   fs		selector for our data segment (fs:0 is stubinfo)
 *   ss:sp	our stack (ss to be freed)
 *   <others>	All unspecified registers have unspecified values in them.
*****************************************************************************/

asm ("
	.comm	__stklen, 4
	.comm	__stubinfo, 4
	.comm	___djgpp_base_address, 4
	.comm	___djgpp_selector_limit, 4
	.lcomm	sel_buf, 8");
	/* ___djgpp_ds_alias defined in go32/exceptn.s */

asm ("
	.data

___djgpp_memory_handle_pointer:
	.long	___djgpp_memory_handle_list+8"); /* Next free, first for stub */
asm ("	.comm	___djgpp_memory_handle_list, 2048"); /* Enough for 256 handles */

asm ("
sbrk16_first_byte:
	.byte	0x12,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x02,0x00,0x00,0x00,0x00,0x00,0x00
	.byte	0x00,0x00,0x8c,0xd8,0x2e,0x8e,0x1e,0x06,0x00,0x89,0x06,0x10,0x00,0x8c,0x16,0x0a
	.byte	0x00,0x66,0x89,0x26,0x0c,0x00,0x8e,0x16,0x06,0x00,0x66,0xbc,0x70,0x02,0x00,0x00
	.byte	0xb8,0x03,0x05,0xcd,0x31,0x72,0x24,0x89,0xca,0x89,0xd9,0x8b,0x1e,0x02,0x00,0xb8
	.byte	0x07,0x00,0xcd,0x31,0x8b,0x1e,0x04,0x00,0xb8,0x07,0x00,0xcd,0x31,0x06,0x07,0x0f
	.byte	0xa0,0x0f,0xa1,0x0f,0xa8,0x0f,0xa9,0x89,0xcb,0x89,0xd1,0x8e,0x16,0x0a,0x00,0x66
	.byte	0x8b,0x26,0x0c,0x00,0x8e,0x1e,0x10,0x00,0x66,0xcb,0x90,0x90
sbrk16_last_byte:

sbrk16_api_ofs:
	.long	0
sbrk16_api_seg:
	.word	0
zero:
	.long	0

exit16_first_byte:
	.byte	0xb8,0x01,0x00,0xcd,0x31,0xb8,0x02,0x05,0xcd,0x31,0x88,0xd0,0xb4,0x4c,0xcd,0x21
exit16_last_byte:

hook_387_emulator:
	.long	___emu387_load_hook");

	/* this pulls in the ident string, generated in .. */
asm ("
	.long	___libc_ident_string

stack_allocated:
	.long	0");

	/* this is for when main comes from a library */
asm ("
	.long	_main

	.text

	.globl	start
start:

	pushl	%ds");		/* set %es same as %ds */
asm ("	popl	%es");		/* push/pop 4 bytes shorter than ax */

/* Enable NULL pointer protection if DPMI supports it */
asm ("	testb	$0x1, __crt0_startup_flags+1");	/* include/crt0.h */
asm ("	jnz	1f
	movl	$start, %eax
	cmpl	$0x1000, %eax
	jl	1f
	movw	$0x507, %ax
	.byte 0x64"); /* fs: */
asm ("	movl	0x18, %esi");	/* STUBINFO_MEMORY_HANDLE */
asm ("	xorl	%ebx, %ebx");	/* Offset 0 in mem block */
asm ("	movl	$1, %ecx");	/* Set one page */
asm ("	movl	$zero, %edx
	int	$0x31");	/* Make null page uncommitted */
asm ("
1:");
/* Create an alias for DS to be used by real-mode callbacks (exception handler messes with DS itself) */

asm ("	movw	%ds, %bx
	movw	$0x000a, %ax
	int	$0x31
	jnc	ds_alias_ok
	movb	$0x4c, %ah
	int	$0x21
ds_alias_ok:
	movw	%ax, ___djgpp_ds_alias
	movl	%eax, %ebx
	movw	$0x0009, %al
	movw	%cs, %cx");	/* get CPL from %cs */
asm ("	andl	$3, %ecx
	shll	$5, %ecx");	/* move it into place */
asm ("	orw	$0xc093, %cx
	int	$0x31");	/* set access rights for alias */

/* Maybe set our DS limit to 4Gb in size if flag set */
asm ("	testb	$0x80, __crt0_startup_flags"); /* include/crt0.h */
asm ("	jz	2f
	movw	$0xffff, %cx
	movl	%ecx, %edx
	movw	$0x0008, %ax");	/* reset alias limit to -1 */
asm ("	int	$0x31
	movw	%ds, %bx
	movw	$0x0008, %ax");	/* reset DS limit to -1 */
asm ("	int	$0x31
	jnc	2f
	andb	$0x7f, __crt0_startup_flags"); /* clear it if failure */
asm ("
2:
	testb	$0x8, __crt0_startup_flags+1");		/* include/crt0.h */
asm ("	jz	8f");
/* Allocate some DOS memory and copy our sbrk helper into it. */
asm ("	movl	$sbrk16_first_byte, %esi
	movzwl	8(%esi), %ebx
	shrl	$4, %ebx
	movw	$0x0100, %ax
	int	$0x31
	jnc	dos_alloc_ok
	movb	$0x4c, %ah
	int	$0x21
dos_alloc_ok:
	movw	%cs, 2(%esi)");			/* store API information */
asm ("	movw	%ds, 4(%esi)
	movw	%dx, 6(%esi)");			/* selector for allocated block */

asm ("	movzwl	(%esi), %eax");			/* calculate API address */
asm ("	movl	%eax, sbrk16_api_ofs

	pushl	%es");				/* move the data */
asm ("	movw	%dx, %es
	movl	$(sbrk16_last_byte - sbrk16_first_byte), %ecx
	shrl	$2,%ecx
	xorl	%edi, %edi
	cld
	rep
	movsl
	popl	%es

	movl	%edx, %ebx");			/* dos memory selector */
asm ("	movw	$0x000b, %ax");			/* get descriptor */
asm ("	movl	$sel_buf, %edi
	int	$0x31

	andb	$0xbf, sel_buf+6");		/* make 16-bit */
asm ("	andb	$0xf0, sel_buf+5");		/* remove old type */
asm ("	orb	$0x0a, sel_buf+5");		/* set new type to code/read */

asm ("	xorl	%eax, %eax");			/* allocate new selector */
asm ("	movw	$0x0001, %cx
	int	$0x31
	movw	%ax, sbrk16_api_seg

	movl	%eax, %ebx
	movw	$0x000c, %ax");			/* set descriptor */
asm ("	movl	$sel_buf, %edi
	int	$0x31
8:	movl	$___djgpp_memory_handle_list+8, %edi
	movl	%edi, ___djgpp_memory_handle_pointer
	xorl	%eax, %eax
9:	cmpl	%eax, (%edi)
	je	10f
	mov	%eax, (%edi)
	addl	$4, %edi
	jmp	9b
10:	movw	%cs, %bx
	movw	$0x0006,%ax
	int	$0x31
	movl	%edx,___djgpp_base_address
	movw	%cx,___djgpp_base_address+2");

/* Initialize the brk/sbrk variables */

asm ("	.byte 0x64"); /* fs: */
asm ("	movl	0x1c, %eax");	/* STUBINFO_INITIAL_SIZE */
asm ("	movl	%eax, __what_size_dpmi_thinks_we_are");

/* Maybe lock the initial block, expects BX:CX */
asm ("	movl	%ecx,%ebx
	movl	%edx,%ecx
	addw	$4096,%cx");			/* Skip null page */
asm ("	adcl	$0,%ebx
	subl	$4096,%eax
	pushl	%eax
	call	lock_memory

	.byte 0x64"); /* fs: */
asm ("	movl	0x18, %eax");	/* STUNINFO_MEMORY_HANDLE */
asm ("	movl	%eax, ___djgpp_memory_handle_list

	.byte 0x64"); /* fs: */			/* copy stubinfo into local memory */
asm ("	movl	0x10, %eax");	/* STUNINFO_SIZE */
asm ("	pushl	%eax
	call	___sbrk
	movl	%eax, __stubinfo
	movl	%eax, %edi
	.byte 0x64"); /* fs: */
asm ("	movl	0x10, %ecx");	/* STUBINFO_SIZE */
asm ("	shrl	$2, %ecx
	xorl	%esi, %esi");			/* Zero */
asm ("	pushl	%ds
	pushl	%fs
	popl	%ds
	cld
	rep
	movsl
	popl	%ds

	movl	statck_allocated,%eax
	testl	%eax,%eax
	jnz	1f
	movl	__stklen, %eax"); /* get program-requested stack size */
asm ("	.byte 0x64"); /* fs: */
asm ("	movl	0x14, %ecx"); /* STUNINFO_MINISTACK */ /* get stub-requested stack size */
asm ("	cmpl	%ecx, %eax
	jge	use_stubinfo_stack_size");	/* use the larger of the two */
asm ("	movl	%ecx, %eax
	movl	%eax, __stklen");		/* store the actual stack length */
asm ("
use_stubinfo_stack_size:
	pushl	%eax
	call	___sbrk");			/* allocate the memory */
asm ("	cmpl	$-1, %eax
	je	no_memory
	movl	%eax,stack_allocated
1:
	addl	__stklen, %eax
	movw	%ds, %dx");		/* set stack */
asm ("	movw	%dx, %ss
	movl	%eax, %esp

	xorl	%ebp, %ebp
	call	___crt1_startup");		/* run program */
asm ("	jmp	exit

no_memory:
	movb	$0xff, %al
	jmp	exit");

/*-----------------------------------------------------------------------------*/

#define FREESEL(x) movw x, %bx; movw $0x0001, %ax; int $0x31

asm ("
	.global	__exit
	.align	2
__exit:
	movb	4(%esp), %al
exit:
	movb	%al, %cl
	xorl	%eax,%eax
	movw	%ax,%fs
	movw	%ax,%gs
	cli");				/* Just in case they didn't unhook ints */
	/* selector for linear memory */
asm ("	movw	__go32_info_block+26, %ebx
	movw	$0x0001, %ax
	int	$0x31");
	/* DS alias for rmcb exceptions */
asm ("	movw	___djgpp_ds_alias, %bx
	movw	$0x0001, %ax
	int	$0x31
	testb	$0x8, __crt0_startup_flags+1");		/* include/crt0.h */
asm ("	jz	9f");
	/* sbrk cs */
asm ("	movw	sbrk16_api_seg, %bx
	movw	$0x0001, %ax
	int	$0x31
	movw	sbrk16_first_byte+6,%dx"); /* selector for allocated DOS mem */
asm ("	movw	$0x101, %ax
	int	$0x31");			/* Free block and selector */
asm ("
9:	movl	___djgpp_memory_handle_pointer, %ebx
	movl	$__exit, %esp");		/* We will free stack! Old init code as temp stack */
asm ("	jmp	7f
6:	subl	$8, %ebx
	movl	(%ebx), %edi
	movw	2(%ebx), %si
	movw	$0x502, %ax
	int	$0x31
7:	cmpl	$___djgpp_memory_handle_list+8, %ebx
	jne	6b
	xorl	%ebp, %ebp
	movl	__stubinfo, %edx
	movl	0x28(%edx), %eax"); /* STUNINFO_CS_SELECTOR */
asm ("	movw	%ax, sbrk16_api_seg
	xorl	%edi, %edi
	movl	%edi, sbrk16_api_ofs");	/* Offset is zero */

asm ("	movw	0x22(%edx), %es"); /* STUBINFO_DS_SELECTOE */
asm ("	movb	%cl, %dl
	movl	$exit16_first_byte, %esi
	movl	$(exit16_last_byte - exit16_first_byte), %ecx
	cld
	rep
	movsb

	movl	___djgpp_memory_handle_list, %edi
	movl	___djgpp_memory_handle_list+2, %esi");	/* Skip word prefixes */

asm ("	movw	%es,%ax
	movw	%ax,%ss
	movl	$0x400,%esp");		/* Transfer buffer >= 1024 bytes */
asm ("	movw	%ds, %bx
	movw	0x0001, %ax
	int	$0x31
	movw	%cs, %bx");
/* Call exit procedure with BX=32-bit CS; SI+DI=32-bit handle; DL=exit status */
asm ("	.byte 0x2e
	ljmp	sbrk16_api_ofs");

/*-----------------------------------------------------------------------------*/

asm ("
__what_size_app_thinks_it_is:
	.long	end
	.lcomm	__what_we_return_to_app_as_old_size, 4
	.lcomm	__what_size_dpmi_thinks_we_are, 4

lock_memory:");
	/* BX:CX should be linear address; size is pushed on stack */
asm ("	testb	$0x10, __crt0_startup_flags+1"); /* include/crt0.h */
asm ("	jz	13f
	pushl	%esi
	pushl	%edi
	pushl	%eax
	movl	16(%esp),%edi
	movw	18(%esp),%si
	movw	$0x600,%ax
	int	$0x31
	popl	%eax
	popl	%edi
	popl	%esi
13:	ret	$4");			/* Pop the argument */


asm ("
	.global	___sbrk
	.align	2
___sbrk:
	movl	__what_size_app_thinks_it_is, %eax
	movl	4(%esp), %ecx"); /* Increment size */
asm ("	addl	%ecx, %eax
	jnc	brk_common");
	/* Carry is only set if a negative increment or wrap happens.  Negative
	   increment is semi-OK, wrap (only for multiple zone sbrk) isn't. */
asm ("	test	$0x80000000, %ecx");		/* Clears carry */
asm ("	jnz	brk_common
	stc");					/* Put carry back */
asm ("	jmp	brk_common

	.globl	___brk
	.align	2
___brk:
	movl	4(%esp), %eax
	clc

brk_common:
	pushl	%esi
	pushl	%edi
	pushl	%ebx

	movl	__what_size_app_thinks_it_is, %edx");		/* save info */
asm ("	movl	%edx, __what_we_return_to_app_as_old_size
	movl	%eax, __what_size_app_thinks_it_is

	jc	10f");						/* Wrap for multi-zone */
asm ("	cmpl	__what_size_dpmi_thinks_we_are, %eax");		/* don't bother shrinking */
asm ("	jbe	brk_nochange

	testb	$0x8, __crt0_startup_flags+1");		/* include/crt0.h */
asm ("	jz	10f
	addl	$0x0000ffff, %eax");				/* round up to 64K block */
asm ("	andl	$0xffff0000, %eax
	push	%eax");						/* size - save for later */

asm ("	movl	___djgpp_memory_handle_list, %edi");		/* request new size */
asm ("	movw	___djgpp_memory_handle_list+2, %si
	movl	%eax, %ecx");					/* size not limit */
asm ("	movl	%eax, %ebx");					/* size not limit */
asm ("	shrl	$16, %ebx");					/* BX:CX size */

asm ("	movw	$0x0900, %ax");					/* disable interrupts */
asm ("	int	$0x31
	pushl	%eax

	lcall	sbrk16_api_ofs
	setc	%dl");						/* Save carry */

asm ("	popl	%eax");					/* restore interrupts */
asm ("	int	$0x31

	test	%dl,%dl
	popl	%edx
	jne	brk_error

	movl	%edi, ___djgpp_memory_handle_list");		/* store new handle */
asm ("	movw	%si, ___djgpp_memory_handle_list+2
	movl	%ecx, ___djgpp_base_address");			/* store new base address */
asm ("	movw	%bx, ___djgpp_base_address+2

	movl	%edx, %eax
	movl	__what_size_dpmi_thinks_we_are, %ecx
	subl	%ecx, %eax

	addl	___djgpp_base_address, %ecx
	movl	%ecx, %ebx
	shrl	$16, %ebx");					/* BX:CX addr */
asm ("	pushl	%eax");						/* Size */
asm ("	call	lock_memory

	decl	%edx");						/* limit now, not size */
asm ("	jmp	5f");
/* Current allocation not large enough, get another block */
asm ("
10:	movl	%ecx, %eax");					/* Add amt */
asm ("	pushl	%eax");						/* Save orig */
asm ("	addl	$0x0000ffff, %eax");				/* round up to 64K block */
asm ("	andl	$0xffff0000, %eax
	movl	%eax, %edx");					/* Save size */
asm ("	movl	%eax, %ecx
	movl	%eax, %ebx
	shrl	$16, %ebx");					/* BX:CX size */
asm ("	movw	$0x501,%ax
	int	$0x31
	popl	%eax");						/* Orig size */
asm ("	jc	brk_error

	pushl	%edx");						/* Size */
asm ("	call	lock_memory

	pushw	%bx
	pushw	%cx
	popl	%ecx");						/* Linear address */
asm ("	subl	___djgpp_base_address, %ecx");			/* New dpmi size */
asm ("	cmpl	%ecx, __what_size_dpmi_thinks_we_are");		/* Back to back ? */
asm ("	je	4f
	movl	%ecx, __what_size_dpmi_thinks_we_are
	movl	%ecx, __what_we_return_to_app_as_old_size
4:
	movl	__what_we_return_to_app_as_old_size, %ebx");	/* Base for new block */
asm ("	addl	%ebx, %eax");					/* Final address */
asm ("	movl	%eax, __what_size_app_thinks_it_is");
/* Note - save adjusted memory base and memory handle SI:DI here */
asm ("	movl	___djgpp_memory_handle_pointer, %ebx
	movl	%edi, (%ebx)
	movw	%si, 2(%ebx)
	movl	%ecx, 4(%ebx)
	addl	$8, %ebx
	cmpl	$___djgpp_memory_handle_list+2040, %ebx");		/* At end? */
asm ("	je	11f
	movl	%ebx, ___djgpp_memory_handle_pointer");		/* Only if not at end */
asm ("
11:
	addl	%ecx, %edx");					/* Final address */
asm ("	decl	%edx");						/* Limit to end */
/* If we get a block at a lower address we must skip the limit change */
asm ("	cmpl	___djgpp_selector_limit, %edx
	jbe	12f
5:	movl	%edx, ___djgpp_selector_limit");
asm ("	movw	$0x0008, %ax");					/* reset CS limit */
asm ("	movw	%cs, %bx
	movl	%edx, %ecx
	shrl	$16, %ecx
	int	$0x31");					/* CX:DX is limit */

asm ("	testb	$0x80, __crt0_startup_flags");			/* include/crt0.h */
asm ("	jnz	3f
	movw	$0x0008, %ax");					/* reset DS limit */
asm ("	movw	%ds, %bx
	int	$0x31

	movw	$0x0008, %ax");					/* reset DS alias limit */
asm ("	movl	___djgpp_ds_alias, %ebx
	int	$0x31
3:
	movw	$0x0007, %ax");					/* reset DS alias base */
asm ("	movl	___djgpp_ds_alias, %ebx
	movl	___djgpp_base_address, %edx
	movw	___djgpp_base_address+2, %cx
	int	$0x31

	movl	___djgpp_selector_limit, %edx
12:	incl	%edx");						/* Size not limit */
asm ("	testb	$0x60, __crt0_startup_flags");	/* include/crt0.h */
asm ("	jz	no_fill_sbrk_memory
	pushl	%ds
	popl	%es

	movl	__what_size_dpmi_thinks_we_are, %edi");		/* set all newly resized bytes zero */
asm ("	movl	%edx, %ecx");					/* Limit */
asm ("	subl	%edi, %ecx");			/* Adjust count for base */
asm ("	xorl	%eax, %eax
	testb	$0x40, __crt0_startup_flags
	jz	no_deadbeef
	movl	$0xdeadbeef, %eax");		/* something really easy to spot */
asm ("
no_deadbeef:
	shrl	$2, %ecx");			/* div 4 Longwords not bytes */
asm ("	cld
	rep
	stosl
no_fill_sbrk_memory:
	movl	%edx, __what_size_dpmi_thinks_we_are

brk_nochange:");				/* successful return */
asm ("	movl	__what_we_return_to_app_as_old_size, %eax
	jmp	brk_return

brk_error:");					/* error return */
asm ("	movl	__what_we_return_to_app_as_old_size, %eax
	movl	%eax, __what_size_app_thinks_it_is
	movl	$-1, %eax

brk_return:
	popl	%ebx
	popl	%edi
	popl	%esi
	ret

	.globl	__crt0_init_mcount
__crt0_init_mcount:
	ret");
#else
#ifdef emacs
#include <config.h>
#endif

/*		********  WARNING ********
    Do not insert any data definitions before data_start!
    Since this is the first file linked, the address of the following
    variable should correspond to the start of initialized data space.
    On some systems this is a constant that is independent of the text
    size for shared executables.  On others, it is a function of the
    text size. In short, this seems to be the most portable way to
    discover the start of initialized data space dynamically at runtime,
    for either shared or unshared executables, on either swapping or
    virtual systems.  It only requires that the linker allocate objects
    in the order encountered, a reasonable model for most Unix systems.
    Similarly, note that the address of _start() should be the start
    of text space.   Fred Fish, UniSoft Systems Inc.  */

int data_start = 0;

#ifdef NEED_ERRNO
int errno;
#endif

#ifndef DONT_NEED_ENVIRON
char **environ;
#endif

#ifndef static
/* On systems where the static storage class is usable, this function
   should be declared as static.  Otherwise, the static keyword has
   been defined to be something else, and code for those systems must
   take care of this declaration appropriately.  */
static start1 ();
#endif

#ifdef APOLLO
extern	char   *malloc(), *realloc(), *(*_libc_malloc) (), *(*_libc_realloc)();
extern	void	free(),	(*_libc_free) (); extern int main();
std_$call void  unix_$main();

_start()
{
	_libc_malloc = malloc;
	_libc_realloc = realloc;
	_libc_free = free;
	unix_$main(main);	/* no return */
}
#endif /* APOLLO */

#if defined(orion) || defined(pyramid) || defined(celerity) || defined(ALLIANT) || defined(clipper) || defined(sps7)

#if defined(sps7) && defined(V3x)
        asm("	section	10");
        asm("	ds.b	0xb0");
#endif

#ifdef ALLIANT
/* _start must initialize _curbrk and _minbrk on the first startup;
   when starting up after dumping, it must initialize them to what they were
   before the dumping, since they are in the shared library and
   are not dumped.  See ADJUST_EXEC_HEADER in m-alliant.h.  */
extern unsigned char *_curbrk, *_minbrk;
extern unsigned char end;
unsigned char *_setbrk = &end;
#ifdef ALLIANT_2800
unsigned char *_end = &end;
#endif
#endif

#ifndef DUMMIES
#define DUMMIES
#endif

_start (DUMMIES argc, argv, envp)
     int argc;
     char **argv, **envp;
{
#ifdef ALLIANT
#ifdef ALLIANT_2800
  _curbrk = _end;
  _minbrk = _end;
#else
  _curbrk = _setbrk;
  _minbrk = _setbrk;
#endif
#endif

  environ = envp;

  exit (main (argc, argv, envp));
}

#endif /* orion or pyramid or celerity or alliant or clipper */

#if defined (ns16000) && !defined (sequent) && !defined (UMAX) && !defined (CRT0_DUMMIES)

_start ()
{
/* On 16000, _start pushes fp onto stack */
  start1 ();
}

/* ignore takes care of skipping the fp value pushed in start.  */
static
start1 (ignore, argc, argv)
     int ignore;
     int argc;
     register char **argv;
{
  environ = argv + argc + 1;

  if (environ == *argv)
    environ--;
  exit (main (argc, argv, environ));
}
#endif /* ns16000, not sequent and not UMAX, and not the CRT0_DUMMIES method */

#ifdef UMAX
_start()
{
	asm("	exit []			# undo enter");
	asm("	.set	exitsc,1");
	asm("	.set	sigcatchall,0x400");

	asm("	.globl	_exit");
	asm("	.globl	start");
	asm("	.globl	__start");
	asm("	.globl	_main");
	asm("	.globl	_environ");
	asm("	.globl	_sigvec");
	asm("	.globl	sigentry");

	asm("start:");
	asm("	br	.xstart");
	asm("	.org	0x20");
	asm("	.double	p_glbl,0,0xf00000,0");
	asm("	.org	0x30");
	asm(".xstart:");
	asm("	adjspb	$8");
	asm("	movd	8(sp),0(sp)	# argc");
	asm("	addr	12(sp),r0");
	asm("	movd	r0,4(sp)	# argv");
	asm("L1:");
	asm("	movd	r0,r1");
	asm("	addqd	$4,r0");
	asm("	cmpqd	$0,0(r1)	# null args term ?");
	asm("	bne	L1");
	asm("	cmpd	r0,0(4(sp))	# end of 'env' or 'argv' ?");
	asm("	blt	L2");
	asm("	addqd	$-4,r0		# envp's are in list");
	asm("L2:");
	asm("	movd	r0,8(sp)	# env");
	asm("	movd	r0,@_environ	# indir is 0 if no env ; not 0 if env");
	asm("	movqd	$0,tos		# setup intermediate signal handler");
	asm("	addr	@sv,tos");
	asm("	movzwd	$sigcatchall,tos");
	asm("	jsr	@_sigvec");
	asm("	adjspb	$-12");
	asm("	jsr	@_main");
	asm("	adjspb	$-12");
	asm("	movd	r0,tos");
	asm("	jsr	@_exit");
	asm("	adjspb	$-4");
	asm("	addr	@exitsc,r0");
	asm("	svc");
	asm("	.align	4		# sigvec arg");
	asm("sv:");
	asm("	.double	sigentry");
	asm("	.double	0");
	asm("	.double	0");

	asm("	.comm	p_glbl,1");
}
#endif /* UMAX */

#ifdef CRT0_DUMMIES

/* Define symbol "start": here; some systems want that symbol.  */
#ifdef DOT_GLOBAL_START
asm("	.text		");
asm("	.globl start	");
asm("	start:		");
#endif /* DOT_GLOBAL_START */

#ifdef NODOT_GLOBAL_START
asm("	text		");
asm("	global start	");
asm("	start:		");
#endif /* NODOT_GLOBAL_START */

#ifdef m68000

/* GCC 2.1, when optimization is turned off, seems to want to push a
   word of garbage on the stack, which screws up the CRT0_DUMMIES
   hack.  So we hand-code _start in assembly language.  */
asm(".text			");
#ifndef sony_news
asm("	.even			");
#else /* sony_news (not gas) */
asm("	.align 2		");
#endif /* sony_news (not gas) */
asm(".globl __start		");
asm("__start:			");
asm("	link a6,#0		");
asm("	jbsr _start1		");
asm("	unlk a6			");
asm("	rts			");

#else /* not m68000 */

_start ()
{
/* On vax, nothing is pushed here  */
/* On sequent, bogus fp is pushed here  */
  start1 ();
}

#endif /* possibly m68000 */

static
start1 (CRT0_DUMMIES argc, xargv)
     int argc;
     char *xargv;
{
  register char **argv = &xargv;
  environ = argv + argc + 1;

  if ((char *)environ == xargv)
    environ--;
  exit (main (argc, argv, environ));

  /* Refer to `start1' so GCC will not think it is never called
     and optimize it out.  */
  (void) &start1;
}
#else /* not CRT0_DUMMIES */

/* "m68k" and "m68000" both stand for m68000 processors,
   but with different program-entry conventions.
   This is a kludge.  Now that the CRT0_DUMMIES mechanism above exists,
   most of these machines could use the vax code above
   with some suitable definition of CRT0_DUMMIES.
   Then the symbol m68k could be flushed.
   But I don't want to risk breaking these machines
   in a version 17 patch release, so that change is being put off.  */

#ifdef m68k			/* Can't do it all from C */
	asm ("	global	_start");
	asm ("	text");
	asm ("_start:");
#ifndef NU
#ifdef STRIDE
	asm ("	comm	havefpu%,2");
#else /* m68k, not STRIDE */
	asm ("  comm	splimit%,4");
#endif /* STRIDE */
	asm ("	global	exit");
	asm ("	text");
#ifdef STRIDE
	asm ("	trap	&3");
	asm ("	mov.w	%d0,havefpu%");
#else /* m68k, not STRIDE */
  	asm ("	mov.l	%d0,splimit%");
#endif /* STRIDE */
#endif /* not NU */
	asm ("	jsr	start1");
	asm ("	mov.l	%d0,(%sp)");
	asm ("	jsr	exit");
	asm ("	mov.l	&1,%d0");	/* d0 = 1 => exit */
	asm ("	trap	&0");
#else /* m68000, not m68k */

#ifdef m68000

#ifdef ISI68K
/* Added by ESM Sun May 24 12:44:02 1987 to get new ISI library to work */
/* Edited by Ray Mon May 15 15:59:56 EST 1989 so we can compile with gcc */
#if defined(BSD4_3) && !defined(__GNUC__)
static foo () {
#endif
	asm ("	.globl  is68020");
	asm ("is68020:");
#ifndef BSD4_3
	asm ("	.long   0x00000000");
	asm ("	.long   0xffffffff");
/* End of stuff added by ESM */
#endif
	asm ("	.text");
	asm ("	.globl	__start");
	asm ("__start:");
	asm ("	.word 0");
	asm ("	link	a6,#0");
	asm ("	jbsr	_start1");
	asm ("	unlk	a6");
	asm ("	rts");
#if defined(BSD4_3) && !defined(__GNUC__)
      }
#endif
#else /* not ISI68K */

_start ()
{
#ifdef sun
#ifdef LISP_FLOAT_TYPE
  finitfp_();
#endif
#endif     
/* On 68000, _start pushes a6 onto stack  */
  start1 ();
}
#endif /* not ISI68k */
#endif /* m68000 */
#endif /* m68k */

#if defined(m68k) || defined(m68000)
/* ignore takes care of skipping the a6 value pushed in start.  */
static
#if defined(m68k)
start1 (argc, xargv)
#else
start1 (ignore, argc, xargv)
#endif
     int argc;
     char *xargv;
{
  register char **argv = &xargv;
  environ = argv + argc + 1;

  if ((char *)environ == xargv)
    environ--;
#ifdef sun_68881
  asm("    jsr     f68881_used");
#endif
#ifdef sun_fpa
  asm("    jsr     ffpa_used");
#endif
#ifdef sun_soft
  asm("    jsr     start_float");
#endif
  exit (main (argc, argv, environ));
}

#endif /* m68k or m68000 */

#endif /* not CRT0_DUMMIES */

#ifdef hp9000s300
int argc_value;
char **argv_value;
#ifdef OLD_HP_ASSEMBLER
	asm("   text");
	asm("	globl __start");
	asm("	globl _exit");
	asm("	globl _main");
	asm("__start");
	asm("	dc.l	0");
	asm("	subq.w	#0x1,d0");
	asm("	move.w	d0,float_soft");
	asm("	move.l	0x4(a7),d0");
	asm("	beq.s	skip_1");
	asm("	move.l	d0,a0");
	asm("	clr.l	-0x4(a0)");
	asm("skip_1");
	asm("	move.l	a7,a0");
	asm("	subq.l	#0x8,a7");
	asm("	move.l	(a0),(a7)");
	asm("	move.l	(a0),_argc_value");
	asm("	addq.l	#0x4,a0");
	asm("	move.l	a0,0x4(a7)");
	asm("	move.l	a0,_argv_value");
	asm("incr_loop");
	asm("	tst.l	(a0)+");
	asm("	bne.s	incr_loop");
	asm("	move.l	0x4(a7),a1");
	asm("	cmp.l	(a1),a0");
	asm("	blt.s	skip_2");
	asm("	subq.l	#0x4,a0");
	asm("skip_2");
	asm("	move.l	a0,0x8(a7)");
	asm("	move.l	a0,_environ");
	asm("	jsr	_main");
	asm("	addq.l	#0x8,a7");
	asm("	move.l	d0,-(a7)");
	asm("	jsr	_exit");
	asm("	move.w	#0x1,d0");
	asm("	trap	#0x0");
	asm("	comm	float_soft,4");
/* float_soft is allocated in this way because C would
   put an underscore character in its name otherwise. */

#else /* new hp assembler */

	asm("	text");
        asm("   global  float_loc");
        asm("   set     float_loc,0xFFFFB000");
 	asm("	global	fpa_loc");
	asm("	set	fpa_loc,0xfff08000");
	asm("	global	__start");
	asm("	global	_exit");
	asm("	global	_main");
	asm("__start:");
	asm("	byte	0,0,0,0");
	asm("	subq.w	&1,%d0");
	asm("	mov.w	%d0,float_soft");
	asm("	mov.w	%d1,flag_68881");
#ifndef HPUX_68010
	asm("	beq.b	skip_float");
	asm("	fmov.l	&0x7400,%fpcr");
/*	asm("	fmov.l	&0x7480,%fpcr"); */
#endif /* HPUX_68010 */
	asm("skip_float:");
	asm("	mov.l	%a0,%d0");
	asm("	add.l	%d0,%d0");
	asm("	subx.w	%d1,%d1");
	asm("	mov.w	%d1,flag_68010");
	asm("	add.l	%d0,%d0");
	asm("	subx.w	%d1,%d1");
	asm("	mov.w	%d1,flag_fpa");
	asm("	tst.l	%d2");
	asm("	ble.b	skip_3");
	asm("	lsl	flag_68881");
	asm("	lsl	flag_fpa");
	asm("skip_3:");
	asm("	mov.l	4(%a7),%d0");
	asm("	beq.b	skip_1");
	asm("	mov.l	%d0,%a0");
	asm("	clr.l	-4(%a0)");
	asm("skip_1:");
	asm("	mov.l	%a7,%a0");
	asm("	subq.l	&8,%a7");
	asm("	mov.l	(%a0),(%a7)");
	asm("	mov.l	(%a0),_argc_value");
	asm("	addq.l	&4,%a0");
	asm("	mov.l	%a0,4(%a7)");
	asm("	mov.l	%a0,_argv_value");
	asm("incr_loop:");
	asm("	tst.l	(%a0)+");
	asm("	bne.b	incr_loop");
	asm("	mov.l	4(%a7),%a1");
	asm("	cmp.l	%a0,(%a1)");
	asm("	blt.b	skip_2");
	asm("	subq.l	&4,%a0");
	asm("skip_2:");
	asm("	mov.l	%a0,8(%a7)");
	asm("	mov.l	%a0,_environ");
	asm("	jsr	_main");
	asm("	addq.l	&8,%a7");
	asm("	mov.l	%d0,-(%a7)");
	asm("	jsr	_exit");
	asm("	mov.w	&1,%d0");
	asm("	trap	&0");
	asm("	comm	float_soft, 4");
	asm("	comm	flag_68881, 4");
	asm("	comm	flag_68010, 4");
	asm("	comm	flag_68040, 4");
	asm("	comm	flag_fpa, 4");

#endif /* new hp assembler */
#endif /* hp9000s300 */

#ifdef GOULD

/* startup code has to be in near text rather
   than fartext as allocated by the C compiler. */
	asm("	.text");
	asm("	.align	2");
	asm("	.globl	__start");
	asm("	.text");
	asm("__start:");
/* setup base register b1 (function base). */
	asm("	.using	b1,.");
	asm("	tpcbr	b1");
/* setup base registers b3 through b7 (data references). */
	asm("	file	basevals,b3");
/* setup base register b2 (stack pointer); it should be
   aligned on a 8-word boundary; but because it is pointing
   to argc, its value should be remembered (in r5). */
	asm("	movw	b2,r4");
	asm("	movw	b2,r5");
	asm("	andw	#~0x1f,r4");
	asm("	movw	r4,b2");
/* allocate stack frame to do some work. */
	asm("	subea	16w,b2");
/* initialize signal catching for UTX/32 1.2; this is
   necessary to make restart from saved image work. */
	asm("	movea	sigcatch,r1");
	asm("	movw	r1,8w[b2]");
	asm("	svc	#1,#150");
/* setup address of argc for start1. */
	asm("	movw	r5,8w[b2]");
	asm("   func	#1,_start1");
	asm("	halt");
/* space for ld to store base register initial values. */
	asm("	.align	5");
	asm("basevals:");
	asm("	.word	__base3,__base4,__base5,__base6,__base7");

static
start1 (xargc)
     int *xargc;
{
  register int	argc;
  register char **argv;

  argc = *xargc;
  argv = (char **)(xargc) + 1;
  environ = argv + argc + 1;

  if (environ == argv)
    environ--;
  exit (main (argc, argv, environ));

}

#endif /* GOULD */

#ifdef elxsi
#include <elxsi/argvcache.h>

extern char **environ;
extern int	errno;
extern void	_init_doscan(), _init_iob();
extern char	end[];
char		*_init_brk = end;

_start()
{
  environ = exec_cache.ac_envp;
  brk (_init_brk);
  errno = 0;
  _init_doscan ();
  _init_iob ();
  _exit (exit (main (exec_cache.ac_argc,
		     exec_cache.ac_argv,
		     exec_cache.ac_envp)));
}
#endif /* elxsi */


#ifdef sparc
asm (".global __start");
asm (".text");
asm ("__start:");
asm ("	mov	0, %fp");
asm ("	ld	[%sp + 64], %o0");
asm ("	add	%sp, 68, %o1");
asm ("	sll	%o0, 2,	%o2");
asm ("	add	%o2, 4,	%o2");
asm ("	add	%o1, %o2, %o2");
asm ("	sethi	%hi(_environ), %o3");
asm ("	st	%o2, [%o3+%lo(_environ)]");
asm ("	andn	%sp, 7,	%sp");
asm ("	call	_main");
asm ("	sub	%sp, 24, %sp");
asm ("	call	__exit");
asm ("	nop");

#endif /* sparc */

#if __FreeBSD__ == 2
char *__progname;
#endif
#ifdef __bsdi__
#include <sys/param.h> /* for version number */
#if defined(_BSDI_VERSION) && (_BSDI_VERSION >= 199501)
char *__progname;
#endif
#endif /* __bsdi__ */

#ifdef luna88k
int (*mach_init_routine)();

	asm("	text");
	asm("	align	4");
	asm("	global	__start");
	asm("__start:");
	asm("	or	r2,r0,r31");

static
start1(argp)
    char **argp;
{
    register int argc;
    register char **argv;

    argc = *((int *)argp);
    argv = argp + 1;
    environ = argv + argc + 1;

    if ((char *)environ == *argv)
	environ--;

    if (mach_init_routine)
	(void) (*mach_init_routine) ();
    errno = 0;

    exit (main (argc, argv, environ));

}
#endif /* luna88k */
#endif /* MSDOS */
