/* THIS FILE IS COMPLETELY SAME WITH OF 19.30.  IT NEEDS PATCH FOR MULE.  */ 
/* MS-DOS specific C utilities.
   Copyright (C) 1993, 1994, 1995 Free Software Foundation, Inc.

This file is part of GNU Emacs.

GNU Emacs is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU Emacs is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Emacs; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* Contributed by Morten Welinder */
/* New display, keyboard, and mouse control by Kim F. Storm */

/* Note: some of the stuff here was taken from end of sysdep.c in demacs. */

#include <config.h>

#ifdef MSDOS
#include "lisp.h"
#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include <sys/time.h>
#include <dos.h>
#include "dosfns.h"
#include "msdos.h"
#include "systime.h"
#include "termhooks.h"
#include "dispextern.h"
#include "termopts.h"
#include "frame.h"
#include "window.h"
#include "disptab.h"
#include <go32.h>
#ifndef GO32WIN
#include <pc.h>
#include <crt0.h>		/* 96.3.24  by K.Fujii */
#endif
#include <ctype.h>
#include <jctype.h>
#include "charset.h"		/* 94.9.22, 95.2.10  by K.Fujii */
#include "coding.h"		/* 95.12.3  by K.Fujii */
#ifdef GO32WIN			/* Go32win Patch '95/02/26 by Y.Matsushima */
#include "go32win.h"
#else
#include <libc/farptrgs.h>
#include <libc/bss.h>
#endif
/* #include <process.h> */
/* Damn that local process.h!  Instead we can define P_WAIT ourselves.  */
#define P_WAIT 1
#ifndef HAVE_SELECT		/* 96.2.12  by K.Fujii */
#include "sysselect.h"
#endif

static unsigned long
event_timestamp ()
{
  struct time t;
  unsigned long s;
  
  gettime (&t);
  s = t.ti_min;
  s *= 60;
  s += t.ti_sec;
  s *= 1000;
  s += t.ti_hund * 10;
  
  return s;
}


/* ------------------------ Mouse control ---------------------------
 *
 * Coordinates are in screen positions and zero based.
 * Mouse buttons are numbered from left to right and also zero based.
 */

int have_mouse;          /* 0: no, 1: enabled, -1: disabled */
#ifndef GO32WIN
static int mouse_visible;

static int mouse_last_x;
static int mouse_last_y;

static int mouse_button_translate[NUM_MOUSE_BUTTONS];
static int mouse_button_count;
/* 95.8.29 K.Fujii */
static int mouse_save_x = -1;
static int mouse_save_y = -1;
static int mouse_movement_x;	/* absolute char width. */
static int mouse_movement_y;	/*               height. */
/* end of patch */

void
mouse_on ()
{
  __dpmi_regs regs;

  if (have_mouse > 0 && !mouse_visible)
    {
      if (termscript)
	fprintf (termscript, "<M_ON>");
      regs.x.ax = 0x0001;
      __dpmi_int (0x33, &regs);
      mouse_visible = 1;
    }
}

void
mouse_off ()
{
  __dpmi_regs regs;

  if (have_mouse > 0 && mouse_visible)
    {
      if (termscript)
	fprintf (termscript, "<M_OFF>");
      regs.x.ax = 0x0002;
      __dpmi_int (0x33, &regs);
      mouse_visible = 0;
    }
}

void
mouse_moveto (x, y)
     int x, y;
{
  __dpmi_regs regs;

  if (termscript)
    fprintf (termscript, "<M_XY=%dx%d>", x, y);
  regs.x.ax = 0x0004;
  mouse_last_x = regs.x.cx = x * mouse_movement_x;
  mouse_last_y = regs.x.dx = y * mouse_movement_y;
  __dpmi_int (0x33, &regs);
}

static int
mouse_pressed (b, xp, yp)
     int b, *xp, *yp;
{
  __dpmi_regs regs;

  if (b >= mouse_button_count)
    return 0;
  regs.x.ax = 0x0005;
  regs.x.bx = mouse_button_translate[b];
  __dpmi_int (0x33, &regs);
  if (regs.x.bx)
    *xp = regs.x.cx / mouse_movement_x,
    *yp = regs.x.dx / mouse_movement_y;
  return (regs.x.bx != 0);
}

static int
mouse_released (b, xp, yp)
     int b, *xp, *yp;
{
  __dpmi_regs regs;

  if (b >= mouse_button_count)
    return 0;
  regs.x.ax = 0x0006;
  regs.x.bx = mouse_button_translate[b];
  __dpmi_int (0x33, &regs);
  if (regs.x.bx)
    *xp = regs.x.cx / mouse_movement_x,
    *yp = regs.x.dx / mouse_movement_y;
  return (regs.x.bx != 0);
}

static void
mouse_get_xy (int *x, int *y)
{
  __dpmi_regs regs;

  regs.x.ax = 0x0003;
  __dpmi_int (0x33, &regs);
  *x = regs.x.cx / mouse_movement_x;
  *y = regs.x.dx / mouse_movement_y;
}

void
mouse_get_pos (f, insist, bar_window, part, x, y, time)
     FRAME_PTR *f;
     int insist;
     Lisp_Object *bar_window, *x, *y;
     enum scroll_bar_part *part;
     unsigned long *time;
{
  int ix, iy;
  __dpmi_regs regs;

  regs.x.ax = 0x0003;
  __dpmi_int (0x33, &regs);
  *f = selected_frame;
  *bar_window = Qnil;
  mouse_get_xy (&ix, &iy);
  selected_frame->mouse_moved = 0;
  *x = make_number (ix);
  *y = make_number (iy);
  *time = event_timestamp ();
}

static void
mouse_check_moved ()
{
  int x, y;

  mouse_get_xy (&x, &y);
  selected_frame->mouse_moved |= (x != mouse_last_x || y != mouse_last_y);
  mouse_last_x = x;
  mouse_last_y = y;
}

/* patch 95.10.24  by K.Fujii */
static void
mouse_range (int xmin, int xmax, int ymin, int ymax)
{
  __dpmi_regs regs;

  regs.x.ax = 0x0007;
  regs.x.cx = xmin * mouse_movement_x;
  regs.x.dx = xmax * mouse_movement_x;
  __dpmi_int (0x33, &regs);

  regs.x.ax = 0x0008;
  regs.x.cx = ymin * mouse_movement_y;
  regs.x.dx = ymax * mouse_movement_y;
  __dpmi_int (0x33, &regs);
}
/* end of patch */

void
mouse_init ()
{
  __dpmi_regs regs;

  if (termscript)
    fprintf (termscript, "<M_INIT>");

  mouse_movement_x = 8;
  mouse_movement_y = MachinePc98 () ? 16 : 8;

  regs.x.ax = 0x0021;
  __dpmi_int (0x33, &regs);

  mouse_range (0, ScreenGetCols () - 1,
	       0, ScreenGetRows () - 1);

  /* 94.6.28, 95.8.15, 95.10.9  by K.Fujii, 94.8.15  by T.Yasuda */
  if (MachinePc98 ()) /* PC-98*1 normal mode */
    {
      regs.x.ax = 0x000a;
      regs.x.bx = 0;
      regs.x.cx = 0xffff;
      regs.x.dx = 0x6400;
      __dpmi_int (0x33, &regs);
    }
  /* end of patch */
  mouse_moveto (0, 0);
  mouse_visible = 0;
}
#endif /* ! GO32WIN */

/* ------------------------- Screen control ----------------------
 *
 */

static int internal_terminal = 0;

#ifndef HAVE_X_WINDOWS
#ifndef GO32WIN
/* extern unsigned char ScreenAttrib; */
static int screen_face;
static int highlight;

#if 0 /* 96.1.15  by K.Fujii */
static int screen_size_X;
static int screen_size_Y;
static int screen_size;

static int current_pos_X;
static int current_pos_Y;
static int new_pos_X;
static int new_pos_Y;
#endif

static void *startup_screen_buffer;
static int startup_screen_size_X;
static int startup_screen_size_Y;
static int startup_pos_X;
static int startup_pos_Y;

static int term_setup_done;
#endif /* !GO32WIN */

/* Similar to the_only_frame.  */
struct x_output the_only_x_display;

/* This is never dereferenced.  */
Display *x_current_display;

#ifndef GO32WIN
extern int print_ascii_in_jis;		/* print flag 0x5c Yen-mark or
					   back-slash.
					   see src/msdos/libsrc/at98/screen.c */

#if 1 /* 96.1.15  K.Fujii */
#define dos_direct_output(y,x,b,l) ScreenOutputString (x, y, b, l, ScreenAttrib)
#define SCREEN_SET_CURSOR() ScreenSetCursor (sw.y, sw.x)
#define new_pos_X sw.x
#define new_pos_Y sw.y
#define current_pos_X sw.old_x
#define current_pos_Y sw.old_y
#define screen_size sw._screen_size
#define screen_size_X ScreenGetCols ()
#define screen_size_Y ScreenGetRows ()

void
ScreenReSize (int rows, int cols, int mouseoff)
{
  if (noninteractive) return;

  {
    int redraw = 0;
    int old_cols = ScreenGetCols () - 1;
    int old_rows = ScreenGetRows () - 1;

    if (rows > 0 && rows != ScreenGetRows ())
      {
	ScreenSetRows (rows);
	redraw = 1;
      }
    if (cols > 0 && cols != ScreenGetCols ())
      {
	ScreenSetCols (cols);
	redraw = 1;
      }

    if (redraw)
      {
	int mouse_x, mouse_y;

	if (have_mouse > 0)
	  {
	    mouse_get_xy (&mouse_x, &mouse_y);
	    if (mouseoff) mouse_off ();
	  }
	ScreenClear ();
	if (ScreenGetRows () <= ScreenScrollEnd ())
	  ScreenSetScrollEnd (ScreenGetRows () - 1);
	change_frame_size (selected_frame, ScreenGetRows (), ScreenGetCols (), 0, 0);
	Frecenter (Qnil);
	Fredraw_display ();
	if (have_mouse > 0)
	  {
	    mouse_range (0, ScreenGetCols () - 1, 0, ScreenGetRows () - 1);
	    if (mouse_x >= ScreenGetCols () || mouse_x == old_cols)
	      mouse_x = ScreenGetCols () - 1;
	    if (mouse_y >= ScreenGetRows () || mouse_y == old_rows)
	      mouse_y = ScreenGetRows () - 1;
	    mouse_moveto (mouse_x, mouse_y);
	    mouse_on ();
	  }
      }
  }
}
#else /* 1 */
#define SCREEN_SET_CURSOR() 						\
  if (current_pos_X != new_pos_X || current_pos_Y != new_pos_Y) 	\
    ScreenSetCursor (current_pos_Y = new_pos_Y, current_pos_X = new_pos_X)

static
dos_direct_output (y, x, buf, len)
     int y;
     int x;
     char *buf;
     int len;
{
  int t = (int) ScreenPrimary + 2 * (x + y * screen_size_X);
  
  while (--len >= 0) {
    dosmemput (buf++, 1, t);
    t += 2;
  }
}
#endif /* 1 */
#endif /* ! GO32WIN */

/* patch 95.3.26, 95.12.5  by K.Fujii */
DEFUN ("internal-terminal-p", Finternal_terminal_p,
       Sinternal_terminal_p, 0, 0, 0, "")
     ()
{
  if (inhibit_window_system &&
      internal_terminal)
    return Qt;
  return Qnil;
}
/* end of patch */

#ifndef GO32WIN
/* Flash the screen as a substitute for BEEPs.  */

static void
do_visible_bell (xorattr)
     unsigned char xorattr;
{
  EMACS_TIME t;
  SELECT_TYPE rfds;
  unsigned char *screenbuffer, *p, *p1, *p2;
  int rows, cols, ncol, nrow, col_start, row_start, onelinebyts;
  int i, j;

  rows = ScreenGetRows ();
  nrow = rows / 2;
  row_start = nrow / 2;
  cols = ScreenGetCols ();
  ncol = cols / 2;
  col_start = ncol / 2;
  onelinebyts = cols * 2;

  screenbuffer = (unsigned char *) xmalloc ((rows * cols) * 2);
  p2 = screenbuffer + ((row_start * cols) + col_start) * 2;

  ScreenRetrieve (screenbuffer);

  for (i = 0, p = p2; i < nrow; i++)
    {
      p1 = p, p += onelinebyts;
      for (j = 0; j < ncol; j++)
	p1++, *p1++ ^= xorattr;
    }
  ScreenUpdate (screenbuffer);

#if 0
  FD_SET (0, &rfds);
  EMACS_SET_SECS (t, 1);
  EMACS_SET_USECS (t, 0);
  sys_select (1, &rfds, 0, 0, &t);
#else
  {
    EMACS_TIME timeout, wakeup;

    EMACS_GET_TIME (wakeup);
    EMACS_SET_USECS (wakeup, EMACS_USECS (wakeup) + 150000);
    EMACS_SET_SECS (wakeup, EMACS_SECS (wakeup) + EMACS_USECS (wakeup) / 1000000);
    EMACS_SET_USECS (wakeup, EMACS_USECS (wakeup) % 1000000);
    while (1) {
      EMACS_GET_TIME (timeout);
      EMACS_SUB_TIME (timeout, wakeup, timeout);
      if (EMACS_TIME_NEG_P (timeout))
	break;
      sys_select (1, NULL, NULL, NULL, &timeout);
    }
  }
#endif

  for (i = 0, p = p2; i < nrow; i++)
    {
      p1 = p, p += onelinebyts;
      for (j = 0; j < ncol; j++)
	p1++, *p1++ ^= xorattr;
    }
  ScreenUpdate (screenbuffer);

  xfree (screenbuffer);
}

static void
ScreenVisualBell (void)
{
  /* patch 96.1.15  by K.Fujii */
  int attr;

  if (MachinePc98 ())
    attr = 0x64;
  else
    attr = ((the_only_x_display.foreground_pixel
	     ^ the_only_x_display.background_pixel)
	    * 0x11) & 0x7f;
  /* end of patch */
  /* This creates an xor-mask that will swap the default fore- and
     background colors.  */
  do_visible_bell (attr);
}
#endif /* ! GO32WIN */

#ifndef GO32WIN
/*
 * If we write a character in the position where the mouse is,
 * the mouse cursor may need to be refreshed.
 */

static void
mouse_off_maybe ()
{
  int x, y;
  
  if (!mouse_visible)
    return;
  
  mouse_get_xy (&x, &y);
  if (y != new_pos_Y || x < new_pos_X)
    return;
  
  mouse_off ();
}

static
IT_ring_bell ()
{
  if (visible_bell)
    {
      mouse_off ();
      ScreenVisualBell ();
    }
  else
    {
      __dpmi_regs regs;
      regs.h.ah = 6;		/* 96.1.15 by K.Fujii not check ^C */
      regs.h.dl = 7;
      __dpmi_int (0x21, &regs);
    }
}

#define IT_set_attribute(a) ScreenAttrib = (a)
#define IT_set_face(f) IT_face_attribute(f, highlight)
#define FACE_DEFAULT (~0)

static unsigned char Color_98 [16] = {
  0x00, 0x20, 0x80, 0xa0,
  0x40, 0x60, 0xc0, 0xe0,
  0xe0, 0x20, 0x80, 0xa0,
  0x40, 0x60, 0xc0, 0xe0
};

XFontStruct IT_font_tab [IT_FONT_MAX];

static int
IT_face_attribute (int face, int hilit)
{
  int attr, font, fore, back;
  extern struct face *intern_face (/* FRAME_PTR, struct face * */);
  struct face *fp = FRAME_DEFAULT_FACE (selected_frame);

  font = fore = back = 0;

  if (face != 0)
    {
      if (face < 0 || face >= FRAME_N_COMPUTED_FACES (selected_frame) ||
	  FRAME_COMPUTED_FACES (selected_frame) [face] == 0)
	abort ();
      if (face == 1)
	fp = FRAME_MODE_LINE_FACE (selected_frame);
      else
	fp = intern_face (selected_frame, FRAME_COMPUTED_FACES (selected_frame) [face]);
    }
  else if (hilit)
    fp = FRAME_MODE_LINE_FACE (selected_frame);

  if (fp->font >= &IT_font_tab[0] &&
      fp->font <= &IT_font_tab[IT_FONT_MAX] &&
      fp->font->u.id != FACE_DEFAULT)
    font |= ((fp->font->u.id) & 0x1f);
  if (MachinePc98 ())
    {
      if (fp->bold) font |= 1;
      if (fp->italic) font |= 2;
      if (fp->underline) font |= 8;
      if (fp->background != FACE_DEFAULT &&
	  fp->background != FACE_COLOR_BLACK)
	back = Color_98 [fp->background & 0x0f] | 4;
      else
	fore = Color_98 [(fp->foreground != FACE_DEFAULT
			  ? fp->foreground : the_only_x_display.foreground_pixel) & 0x0f];
    }
  else
    {
      if (fp->bold) font |= 8;
      back = (((fp->background != FACE_DEFAULT
		? fp->background : the_only_x_display.background_pixel)
	       << 4) & 0xf0);
      fore = ((fp->foreground != FACE_DEFAULT
	       ? fp->foreground : the_only_x_display.foreground_pixel)
	      & 0x0f);
    }
  if (termscript)
    {
      fprintf (termscript, "<FACE:%d:%d>", fore, back);
      if (font)
	fprintf (termscript, "<FONT:%s>", fp->font->internal);
    }

  attr = (font | fore | back);
  screen_face = face;
  return attr;
}

static int
IT_write_glyphs (GLYPH *src, int len)
{
  GLYPH *s = src, *endp = src + len, g, g1;
  int tlen = GLYPH_TABLE_LENGTH;
  Lisp_Object *tbase = GLYPH_TABLE_BASE;
  int attr, old_attr, defattr;
  int rev_dir = MachinePc98 () ? 1 : 8;
  coding_type mccode;
  unsigned char buf [4], buf1[4];
  unsigned char *dp, *dst;
  int c_bytes ;
  int face = 0, old_face;
  int output = 0;
  int i, j;
  static int allocated = 0;
  static unsigned char *buffer = 0;

  extern Lisp_Object Vdisplay_coding_system;
  extern FILE *termscript;

  if (! len) return;

 if (allocated <= 0)
    {
      allocated = len * 10;
      buffer = (unsigned char *)xmalloc (allocated);
    }
  else if (allocated < len * 10)
    {
      allocated = len * 10;
      buffer = (unsigned char *)xrealloc (buffer, allocated);
    }
  dp = buffer;

  old_attr = IT_set_face (0);
  old_face = screen_face;
  IT_set_attribute (old_attr);

  encode_code (Vdisplay_coding_system, &mccode);

  while (src < endp && *src & GLYPH_CTL_COLUMN2) src++;
  if (src >= endp) return;
  s = src;

  mouse_off ();			/* patch 96.2.12  by K.Fujii */

  while (1)
    {
      g = *src;
      while (++s < endp && *s & GLYPH_CTL_COLUMN2);
      if (GLYPH_LEADING_CHAR (g) == LCCMP)
	{
	  int idx = GLYPH_CHAR (selected_frame, g) & (CHAR_F2_MASK | CHAR_F3_MASK);

	  if (idx < n_cmpchars)
	    {
	      g = *cmpchar_table[idx].glyph;
	      c_bytes = CHARtoSTR (GLYPH_CHAR (selected_frame, g), buf);
	    }
	  else c_bytes = 1;
	}
      else
	c_bytes = CHARtoSTR (GLYPH_CHAR (selected_frame, g), buf);

      face = GLYPH_FACE (selected_frame, g);
      if (face != old_face)
	{
	  attr = (IT_set_face (face)
		  | (((g & GLYPH_CTL_REV_DIR) && highlight_reverse_direction)
		     ? rev_dir : 0));
	  if (attr != old_attr)
	    {
	      if (output > 0)
		{
		  dos_direct_output (new_pos_Y, new_pos_X, buffer, output);
		  if (termscript)
		    fwrite (buffer, 1, output, termscript);
		  ScreenForwardX (output);
		  output = 0;
		  dp = buffer;
		}
	      IT_set_attribute (attr);
	      old_attr = attr;
	    }
	  old_face = face;
	}

      if (s >= endp) CODE_CNTL (&mccode) |= CC_END;
      c_bytes = decode (&mccode, buf, buf1, c_bytes);
      for (i = 0; i < c_bytes; i++)
	{
	  g1 = MAKE_GLYPH (selected_frame, buf1[i], 0);
	  if (GLYPH_CHAR (selected_frame, g1) >= tlen)
	    {
	    simple:
	      *dp++ = GLYPH_CHAR (selected_frame, g1);
	      output++;
	    }
	  else
	    {
	      GLYPH_FOLLOW_ALIASES (tbase, tlen, g1);
	      if (GLYPH_SIMPLE_P (tbase, tlen, g1))
		goto simple;
	      else
		{
		  unsigned char *galias = GLYPH_STRING (tbase, g1);

		  j = GLYPH_LENGTH (tbase, g1);
		  while (j--)
		    {
		      *dp++ = *galias++;
		      output++;
		    }
		}
	    }
	}
      if ((src = s) >= endp) break;
    }
  if (output > 0)
    {
      dos_direct_output (new_pos_Y, new_pos_X, buffer, output);
      if (termscript)
	fwrite (buffer, 1, output, termscript);
      ScreenForwardX (output);
    }

  IT_set_attribute (IT_face_attribute (0, 0));
}
/* end of patch */

static
IT_clear_end_of_line (int first_unused)
{
  char *spaces;
  int i, j, k;

  IT_set_face (0);
  if (termscript)
    fprintf (termscript, "<CLR:EOL>");
  /* patch 96.1.15  by K.Fujii */
  mouse_off_maybe ();

  j = new_pos_X;
  i = ScreenGetCols () - j;

  spaces = (char *) alloca (i);
  for (k = 0; k < i; k++)
    spaces [k] = ' ';
  dos_direct_output (ScreenGetPosY (), j,
		     spaces, i);
  /* end of patch */
}

static
IT_clear_screen (void)
{
  if (termscript)
    fprintf (termscript, "<CLR:SCR>");
  IT_set_face (0);
  mouse_off ();
  ScreenClear ();
  new_pos_X = new_pos_Y = 0;
}

static
IT_clear_to_end (void)
{
  if (termscript)
    fprintf (termscript, "<CLR:EOS>");

  while (new_pos_Y < screen_size_Y) {
    new_pos_X = 0;
    IT_clear_end_of_line (0);
    /* patch 96.2.3  by K.Fujii */
    ScreenNextY (1);
  }
}

static
IT_cursor_to (int y, int x)
{
  if (termscript)
    fprintf (termscript, "\n<XY=%dx%d>", x, y);
  /* patch 96.2.3  by K.Fujii */
  ScreenSetPos (y, x);
  /* end of patch */
}

static
IT_reassert_line_highlight (new, vpos)
     int new, vpos;
{
  highlight = new;
  IT_set_face (0); /* To possibly clear the highlighting.  */
}

static
IT_change_line_highlight (int new_highlight, int vpos, int first_unused_hpos)
{
  highlight = new_highlight;
  IT_set_face (0); /* To possibly clear the highlighting.  */
  IT_cursor_to (vpos, 0);
  IT_clear_end_of_line (first_unused_hpos);
}

static
IT_update_begin ()
{
  highlight = 0;
  IT_set_face (0); /* To possibly clear the highlighting.  */
  screen_face = -1;
}

static
IT_update_end ()
{
}

/* This was more or less copied from xterm.c */
static void
IT_set_menu_bar_lines (window, n)
  Lisp_Object window;
  int n;
{
  struct window *w = XWINDOW (window);

  XSETFASTINT (w->last_modified, 0);
  XSETFASTINT (w->top, XFASTINT (w->top) + n);
  XSETFASTINT (w->height, XFASTINT (w->height) - n);

  /* Handle just the top child in a vertical split.  */
  if (!NILP (w->vchild))
    IT_set_menu_bar_lines (w->vchild, n);

  /* Adjust all children in a horizontal split.  */
  for (window = w->hchild; !NILP (window); window = w->next)
    {
      w = XWINDOW (window);
      IT_set_menu_bar_lines (window, n);
    }
}

/*
 * IT_set_terminal_modes is called when emacs is started,
 * resumed, and whenever the screen is redrawn!
 */

static
IT_set_terminal_modes (void)
{
  char *colors;
  FRAME_PTR f;
  struct face *fp;

  if (termscript)
    fprintf (termscript, "\n<SET_TERM>");
  highlight = 0;

#if 0 /* 96.1.15  by K.Fujii */
  screen_size_X = ScreenCols ();
  screen_size_Y = ScreenRows ();
  screen_size = screen_size_X * screen_size_Y;
#endif

  new_pos_X = new_pos_Y = 0;
  current_pos_X = current_pos_Y = -1;

  if (term_setup_done)
    return;
  term_setup_done = 1;
  
  startup_screen_size_X = screen_size_X;
  startup_screen_size_Y = screen_size_Y;

  ScreenGetCursor (&startup_pos_Y, &startup_pos_X);
  mouse_off ();			/* 96.2.12  by K.Fujii */
  ScreenRetrieve (startup_screen_buffer = xmalloc (screen_size * 2));

  if (termscript)
    fprintf (termscript, "<SCREEN SAVED>\n");
}

/*
 * IT_reset_terminal_modes is called when emacs is
 * suspended or killed.
 */

static
IT_reset_terminal_modes (void)
{
  int print_ascii_in_jis_saved = print_ascii_in_jis;

  if (termscript)
    fprintf (termscript, "\n<RESET_TERM>");

  highlight = 0;

  if (!term_setup_done)
    return;

  mouse_off ();			/* 96.2.12  by K.Fujii */
  print_ascii_in_jis = 1;
  ScreenUpdate (startup_screen_buffer);
  print_ascii_in_jis = print_ascii_in_jis_saved;
  ScreenSetCursor (startup_pos_Y, startup_pos_X);
  xfree (startup_screen_buffer);

  if (termscript)
    fprintf (termscript, "<SCREEN RESTORED>\n");

  term_setup_done = 0;
}

/* patch 96.1.15  by K.Fujii */
static void
IT_set_scroll_region (int start, int stop)
{
  ScreenScrollRange (start, stop - 1);
}

extern int specified_window;

static
IT_ins_del_lines (int vpos, int n)
{
  int i = n > 0 ? n : -n;

  if (vpos + i >= specified_window ||
      vpos + i >= FRAME_HEIGHT (selected_frame))
    return;

  mouse_off ();
  IT_set_scroll_region (vpos, specified_window);
  IT_cursor_to (vpos, 0);
  if (n < 0) ScreenScrollUp (i);
  else       ScreenScrollDown (i);
  IT_set_scroll_region (0, specified_window);
}
/* end of patch */

static
IT_set_terminal_window (int size)
{
  /* patch 96.1.16  by K.Fujii */
  specified_window = size ? size : FRAME_HEIGHT (selected_frame);
  IT_set_scroll_region (0, specified_window);
  /* end of patch */
}

#ifndef FACE_DEFAULT
#define FACE_DEFAULT (~0)
#endif

void
IT_set_frame_parameters (frame, alist)
     FRAME_PTR frame;
     Lisp_Object alist;
{
  Lisp_Object tail;
  int redraw;
  extern unsigned long msdos_load_color (); /* 96.1.16  by K.Fujii */
  FRAME_PTR f = (FRAME_PTR) &the_only_frame;

  redraw = 0;
  for (tail = alist; CONSP (tail); tail = Fcdr (tail))
    {
      Lisp_Object elt, prop, val;

      elt = Fcar (tail);
      prop = Fcar (elt);
      val = Fcdr (elt);
      CHECK_SYMBOL (prop, 1);

      if (EQ (prop, intern ("foreground-color")))
	{
	  unsigned long new_color = msdos_load_color (f, val); /* 96.1.16  by K.Fujii */
	  if (new_color != ~0)
	    {
	      FRAME_FOREGROUND_PIXEL (f) = new_color;
	      redraw = 1;
	    }
	}
      else if (EQ (prop, intern ("background-color")))
	{
	  unsigned long new_color = msdos_load_color (f, val); /* 96.1.16  by K.Fujii */
	  if (new_color != ~0)
	    {
	      FRAME_BACKGROUND_PIXEL (f) = new_color /* & ~8 */; /* 96.1.16  by K.Fujii */
	      redraw = 1;
	    }
	}
      else if (EQ (prop, intern ("menu-bar-lines")))
	{
	  int new;
	  int old = FRAME_MENU_BAR_LINES (the_only_frame);

	  if (INTEGERP (val))
	    new = XINT (val);
	  else
	    new = 0;
	  FRAME_MENU_BAR_LINES (f) = new;
	  IT_set_menu_bar_lines (the_only_frame.root_window, new - old);
	}
      /* patch 96.1.16  by K.Fujii */
      else if (EQ (prop, intern ("font")))
	{
	  if (SYMBOLP(val)) val = Fsymbol_name (val);
	  if (! STRINGP (val)) FRAME_FONT (frame) = (XFontStruct *)FACE_DEFAULT;
	  else
	    {
	      int f;
	      XFontStruct *font;

	      for (f = 0, font = IT_font_tab; f < IT_FONT_MAX; f++, font++)
		{
		  if (font->u.id != FACE_DEFAULT &&
		      font->internal  &&
		      ! strcmp(XSTRING (val)->data, font->internal))
		    {
		      FRAME_FONT (frame) = font;
		      redraw = 1;
		      break;
		    }
		}
	    }
	}
      /* end of patch */
    }

  if (redraw)
    {
      recompute_basic_faces (f);
      Fredraw_frame (Fselected_frame ());
    }
}
#endif /* ! GO32WIN */
#endif /* !HAVE_X_WINDOWS */

/* Do we need the internal terminal? */
#ifdef GO32WIN

XFontStruct IT_font_tab [IT_FONT_MAX];

void
internal_terminal_init (void)
{
  int i;
  extern int DefAttr;

  internal_terminal= 0;
  the_only_frame.output_method = output_termcap;

  IT_font_tab[0].internal = (unsigned char *) 0L;
  IT_font_tab[0].u.alias = (unsigned char *) 0L;
  if (IT_font_tab[1].internal) xfree (IT_font_tab[1].internal);
  if (IT_font_tab[1].u.alias) xfree (IT_font_tab[1].u.alias);
  IT_font_tab[1].internal = (unsigned char *)xmalloc (sizeof ("default") + 1);
  strcpy (IT_font_tab[1].internal, "default");
  IT_font_tab[1].u.alias = (unsigned char *) xmalloc (sizeof ("System") + 1);
  strcpy (IT_font_tab[1].u.alias, "System");
  for (i = 2; i < GO32WIN_MAXFACE; i++) {
    if (IT_font_tab[i].internal) xfree (IT_font_tab[i].internal);
    if (IT_font_tab[i].u.alias) xfree (IT_font_tab[i].u.alias);
    IT_font_tab [i].internal = IT_font_tab[i].u.alias = (unsigned char *) 0L;
  }
  DefAttr = 0xf0;
}
#else /* not GO32WIN */
void
internal_terminal_init ()
{
  char *term = getenv ("TERM");
  char *colors;
  int f = 0;			/* 96.1.16  by K.Fujii */

#ifdef HAVE_X_WINDOWS
  if (!inhibit_window_system)
    return;
#endif

  /* patch 94.7.8, 95.2.7, 95.2.15  by K.Fujii, 94.8.15  by T.Yasuda */
  internal_terminal
    = term && !strncmp (term, "internal", 8);

  if (getenv ("EMACSTEST"))
    termscript = fopen (getenv ("EMACSTEST"), "wt");
  
#ifndef HAVE_X_WINDOWS
  if (!internal_terminal) /* 96.1.16 by K.Fujii */
    {
      the_only_frame.output_method = output_termcap;
      return;
    }

  /* patch 96.1.16  by K.Fujii */
  if (! inhibit_window_system)
    {
      Vwindow_system = intern ("pc");
      Vwindow_system_version = make_number (1);
    }
 
  bzero (&the_only_x_display, sizeof the_only_x_display);
  /* patch 96.1.16  by K.Fujii */
  bzero (IT_font_tab, sizeof (XFontStruct) * IT_FONT_MAX);
  IT_font_tab[f++].internal = "default";
  if (MachinePc98 ())
    {
      the_only_x_display.background_pixel = 0;
      the_only_x_display.foreground_pixel = 7;
      IT_font_tab[f].internal = "bold";
      IT_font_tab[f++].u.id = 1;
      IT_font_tab[f].internal = "italic";
      IT_font_tab[f++].u.id = 2;
      IT_font_tab[f].internal = "bold-italic";
      IT_font_tab[f++].u.id = 9;
      IT_font_tab[f].internal = "underline";
      IT_font_tab[f++].u.id = 8;
      IT_font_tab[f].internal = "bold-underline";
      IT_font_tab[f++].u.id = 9;
      IT_font_tab[f].internal = "italic-underline";
      IT_font_tab[f++].u.id = 10;
      IT_font_tab[f].internal = "bold-italic-underline";
      IT_font_tab[f++].u.id = 9;
    }
  else
    {
      the_only_x_display.background_pixel = 0x0f; /* White */
      the_only_x_display.foreground_pixel = 0; /* Black */
      IT_font_tab[f].internal = "bold";
      IT_font_tab[f++].u.id = 8;
    }
  while (f < IT_FONT_MAX)
    IT_font_tab[f++].u.id = FACE_DEFAULT;
  /* end of patch */
#if 0 /* 96.1.16  by K.Fujii */
  colors = getenv ("EMACSCOLORS");
  if (colors && strlen (colors) >= 2)
    {
      the_only_x_display.foreground_pixel = colors[0] & 0x07;
      the_only_x_display.background_pixel = colors[1] & 0x07;
    }
#endif
  the_only_x_display.line_height = 1;
  the_only_frame.output_data.x = &the_only_x_display;
  the_only_frame.output_method = output_msdos_raw;
#if 1  /* 96.2.10  by K.Fujii */
  the_only_x_display.font = &IT_font_tab[0];
#else
  the_only_x_display.font = (XFontStruct *)1;   /* must *not* be zero */
#endif

  init_frame_faces ((FRAME_PTR) &the_only_frame);

  ring_bell_hook = IT_ring_bell;
  write_glyphs_hook = IT_write_glyphs;
  cursor_to_hook = raw_cursor_to_hook = IT_cursor_to;
  clear_to_end_hook = IT_clear_to_end;
  clear_end_of_line_hook = IT_clear_end_of_line;
  clear_frame_hook = IT_clear_screen;
  change_line_highlight_hook = IT_change_line_highlight;
  update_begin_hook = IT_update_begin;
  update_end_hook = IT_update_end;
  reassert_line_highlight_hook = IT_reassert_line_highlight;

  /* These hooks are called by term.c without being checked.  */
  set_terminal_modes_hook = IT_set_terminal_modes;
  reset_terminal_modes_hook = IT_reset_terminal_modes;
  set_terminal_window_hook = IT_set_terminal_window;
  ins_del_lines_hook = IT_ins_del_lines;
#endif /* ! HAVE_X_WINDOWS */
}

dos_get_saved_screen (screen, rows, cols)
     char **screen;
     int *rows;
     int *cols;
{
#ifndef HAVE_X_WINDOWS
  *screen = startup_screen_buffer;
  *cols = startup_screen_size_X;
  *rows = startup_screen_size_Y;
  return 1;
#else
  return 0;
#endif  
}
#endif /* not GO32WIN */


/* ----------------------- Keyboard control ----------------------
 *
 * Keymaps reflect the following keyboard layout:
 *
 *    0  1  2  3  4  5  6  7  8  9  10 11 12  BS
 *    TAB 15 16 17 18 19 20 21 22 23 24 25 26 (41)
 *    CLOK 30 31 32 33 34 35 36 37 38 39 40 (41) RET
 *    SH () 45 46 47 48 49 50 51 52 53 54  SHIFT
 *                    SPACE
 */

static int extend_kbd; /* 101 (102) keyboard present.	*/

#ifndef GO32WIN
struct dos_keyboard_map
{
  unsigned char *unshifted;
  unsigned char *shifted;
  unsigned char *alt_gr;
};

/* patch 96.1.28  by K.Fujii */
static struct dos_keyboard_map pc98_keyboard = {
/*           1          2         3         4         5  */
/* 01234567890123 456789012345678901234567890123456789012345 */
  " 1234567890-^\\  qwertyuiop@[ asdfghjkl;:]zxcvbnm,./_     ",
/*             1         2         3         4         5  */
/* 012 34567 890123456789012345678901234567890123456789012345 */
  " !\"#$%&\'()0=`|  QWERTYUIOP~{ ASDFGHJKL+*}ZXCVBNM<>?_     ",
  0
};

static struct dos_keyboard_map jp_keyboard = {
/* 0         1          2         3         4         5      */
/* 01234567890123 456789012345678901234567890123456789012345 */
  " 1234567890-^\\  qwertyuiop@[  asdfghjkl;:]   zxcvbnm,./_  ",
/* 0           1         2         3         4         5     */
/* 012 34567 890123456789012345678901234567890123456789012345 */
  " !\"#$%&\'()0=~|  QWERTYUIOP`{  ASDFGHJKL+*}   ZXCVBNM<>?_  ",
  0
};

static struct dos_keyboard_map us_keyboard = {
/* 0         1         2         3         4           5     */
/* 01234567890123456789012345678901234567890 1 23456789012345 */
  "`1234567890-=   qwertyuiop[]  asdfghjkl;\'\\   zxcvbnm,./  ",
/* 0         1         2         3         4          5     */
/* 01234567890123456789012345678901234567890 123456789012345 */
  "~!@#$%^&*()_+   QWERTYUIOP{}  ASDFGHJKL:\"|   ZXCVBNM<>?  ",
  0				/* no Alt-Gr key */
};

static struct dos_keyboard_map fr_keyboard = {
/* 0                      1            2         3         4            5      */
/* 0   12   3 4567   89   0   123456789012345678901234567890   123456789012345 */
  "\357&\202\",(-\212_\200\205)=   azertyuiop^$  qsdfghjklm\227*    wxcvbnm;:!  ",
/* 0         1            2               3         4            5      */
/* 012345678901   23456789012345   6   789012345678901   23456789012345 */
  " 1234567890\370+   AZERTYUIOP\371\234  QSDFGHJKLM%\346    WXCVBN?./\365  ",
/* 0          1         2            3         4         5      */
/* 012345678 901234567890123456   78901234567890123456789012345 */
  "  ~#{[|`\\^@]}             \317                              "
};

static struct dos_keyboard_map dk_keyboard = {
/* 0            1         2            3            4             5      */
/* 0   1234567890123456789012345   67890123456789   0   1 23456789012345  */
  "\2531234567890+|   qwertyuiop\206~  asdfghjkl\211\233\'   zxcvbnm,.-  ",
/* 0             1         2            3            4            5      */
/* 0   12 34567890123456789012345   67890123456789   0   123456789012345  */
  "\365!\"#$%&/()=?`   QWERTYUIOP\217^  ASDFGHJKL\222\235*   ZXCVBNM;:_  ",
/* 0            1         2         3         4         5      */
/* 0123   4567890123456789012345678901234567890123456789012345  */
  "  @\234$  {[]} |                                            "
};

static struct keyboard_layout_list
{
  int country_code;
  struct dos_keyboard_map *keyboard_map;
} keyboard_layout_list[] =
{
  1, &us_keyboard,
  33, &fr_keyboard,
  45, &dk_keyboard,
  81, &jp_keyboard		/* 96.1.28  by K.Fujii */
};

static struct dos_keyboard_map *keyboard;
static int keyboard_map_all;

int
dos_set_keyboard (code, always)
     int code;
     int always;
{
  int i;

  /* patch 96.1.28  by K.Fujii */
  if (MachinePc98 ())
    {
      keyboard = &pc98_keyboard;
      dos_keyboard_layout = 81;
      keyboard_map_all = 0;
      return 1;
    }
  /* end of patch */
  /* Initialize to US settings, for countries that don't have their own.  */
  keyboard = keyboard_layout_list[0].keyboard_map;
  keyboard_map_all = always;
  dos_keyboard_layout = 1;
  
  for (i = 0; i < (sizeof (keyboard_layout_list)/sizeof (struct keyboard_layout_list)); i++)
    if (code == keyboard_layout_list[i].country_code)
      {
	keyboard = keyboard_layout_list[i].keyboard_map;
	keyboard_map_all = always;
	dos_keyboard_layout = code;
	return 1;
      }
  return 0;
}

#define Ignore	0x0000
#define Normal	0x0000	/* normal key - alt changes scan-code */
#define FctKey	0x1000	/* func key if c == 0, else c */
#define Special	0x2000	/* func key even if c != 0 */
#define ModFct	0x3000	/* special if mod-keys, else 'c' */
#define Map	0x4000	/* alt scan-code, map to unshift/shift key */
#define KeyPad	0x5000	/* map to insert/kp-0 depending on c == 0xe0 */
#define Grey	0x6000	/* Grey keypad key */

#define Alt	0x0100	/* alt scan-code */
#define Ctrl	0x0200	/* ctrl scan-code */
#define Shift	0x0400	/* shift scan-code */

static struct
{
  unsigned char char_code;	/* normal code	*/
  unsigned char meta_code;	/* M- code	*/
  unsigned char keypad_code;	/* keypad code	*/
  unsigned char editkey_code;	/* edit key	*/
} keypad_translate_map[] = {
  '0',  '0',  0xb0, /* kp-0 */		0x63, /* insert */
  '1',  '1',  0xb1, /* kp-1 */		0x57, /* end */
  '2',  '2',  0xb2, /* kp-2 */		0x54, /* down */
  '3',  '3',  0xb3, /* kp-3 */		0x56, /* next */
  '4',  '4',  0xb4, /* kp-4 */		0x51, /* left */
  '5',  '5',  0xb5, /* kp-5 */		0xb5, /* kp-5 */
  '6',  '6',  0xb6, /* kp-6 */		0x53, /* right */
  '7',  '7',  0xb7, /* kp-7 */		0x50, /* home */
  '8',  '8',  0xb8, /* kp-8 */		0x52, /* up */
  '9',  '9',  0xb9, /* kp-9 */		0x55, /* prior */
  '.',  '-',  0xae, /* kp-decimal */	0xff  /* delete */
};

static struct
{
  unsigned char char_code;	/* normal code	*/
  unsigned char keypad_code;	/* keypad code	*/
} grey_key_translate_map[] = {
  '/',  0xaf, /* kp-decimal */
  '*',  0xaa, /* kp-multiply */
  '-',  0xad, /* kp-subtract */
  '+',  0xab, /* kp-add */
  '\r', 0x8d  /* kp-enter */
};

static unsigned short
ibmpc_translate_map[] =
{
  /* --------------- 00 to 0f --------------- */
  Normal | 0xff,	/* Ctrl Break + Alt-NNN */
  Alt | ModFct | 0x1b,		/* Escape */
  Normal | 1,			/* '1' */
  Normal | 2,			/* '2' */
  Normal | 3,			/* '3' */
  Normal | 4,			/* '4' */
  Normal | 5,			/* '5' */
  Normal | 6,			/* '6' */
  Normal | 7,			/* '7' */
  Normal | 8,			/* '8' */
  Normal | 9,			/* '9' */
  Normal | 10,			/* '0' */
  Normal | 11,			/* '-' */
  Normal | 12,			/* '=' */
  Special | 0x08,		/* Backspace */
  ModFct | 0x74,		/* Tab/Backtab */

  /* --------------- 10 to 1f --------------- */
  Map | 16,			/* 'q' */
  Map | 17,			/* 'w' */
  Map | 18,			/* 'e' */
  Map | 19,			/* 'r' */
  Map | 20,			/* 't' */
  Map | 21,			/* 'y' */
  Map | 22,			/* 'u' */
  Map | 23,			/* 'i' */
  Map | 24,			/* 'o' */
  Map | 25,			/* 'p' */
  Map | 26,			/* '[' */
  Map | 27,			/* ']' */ 
  ModFct | 0x0d,		/* Return */
  Ignore,			/* Ctrl */
  Map | 30,			/* 'a' */
  Map | 31,			/* 's' */

  /* --------------- 20 to 2f --------------- */
  Map | 32,			/* 'd' */
  Map | 33,			/* 'f' */
  Map | 34,			/* 'g' */
  Map | 35,			/* 'h' */
  Map | 36,			/* 'j' */
  Map | 37,			/* 'k' */
  Map | 38,			/* 'l' */
  Map | 39,			/* ';' */
  Map | 40,			/* '\'' */
  Map |  0,			/* '`' */
  Ignore,			/* Left shift */
  Map | 41,			/* '\\' */
  Map | 45,			/* 'z' */
  Map | 46,			/* 'x' */
  Map | 47,			/* 'c' */
  Map | 48,			/* 'v' */

  /* --------------- 30 to 3f --------------- */
  Map | 49,			/* 'b' */
  Map | 50,			/* 'n' */
  Map | 51,			/* 'm' */
  Map | 52,			/* ',' */
  Map | 53,			/* '.' */
  Map | 54,			/* '/' */
  Ignore,			/* Right shift */
  Grey | 1,			/* Grey * */
  Ignore,			/* Alt */
  Normal |  ' ',		/* ' ' */
  Ignore,			/* Caps Lock */
  FctKey | 0xbe,		/* F1 */
  FctKey | 0xbf,		/* F2 */
  FctKey | 0xc0,		/* F3 */
  FctKey | 0xc1,		/* F4 */
  FctKey | 0xc2,		/* F5 */

  /* --------------- 40 to 4f --------------- */
  FctKey | 0xc3,		/* F6 */
  FctKey | 0xc4,		/* F7 */
  FctKey | 0xc5,		/* F8 */
  FctKey | 0xc6,		/* F9 */
  FctKey | 0xc7,		/* F10 */
  Ignore,			/* Num Lock */
  Ignore,			/* Scroll Lock */
  KeyPad | 7,			/* Home */
  KeyPad | 8,			/* Up */
  KeyPad | 9,			/* Page Up */
  Grey | 2,			/* Grey - */
  KeyPad | 4,			/* Left */
  KeyPad | 5,			/* Keypad 5 */
  KeyPad | 6,			/* Right */
  Grey | 3,			/* Grey + */
  KeyPad | 1,			/* End */

  /* --------------- 50 to 5f --------------- */
  KeyPad | 2,			/* Down */
  KeyPad | 3,			/* Page Down */
  KeyPad | 0,			/* Insert */
  KeyPad | 10,			/* Delete */
  Shift | FctKey | 0xbe,	/* (Shift) F1 */
  Shift | FctKey | 0xbf,	/* (Shift) F2 */
  Shift | FctKey | 0xc0,	/* (Shift) F3 */
  Shift | FctKey | 0xc1,	/* (Shift) F4 */
  Shift | FctKey | 0xc2,	/* (Shift) F5 */
  Shift | FctKey | 0xc3,	/* (Shift) F6 */
  Shift | FctKey | 0xc4,	/* (Shift) F7 */
  Shift | FctKey | 0xc5,	/* (Shift) F8 */
  Shift | FctKey | 0xc6,	/* (Shift) F9 */
  Shift | FctKey | 0xc7,	/* (Shift) F10 */
  Ctrl | FctKey | 0xbe,		/* (Ctrl) F1 */
  Ctrl | FctKey | 0xbf,		/* (Ctrl) F2 */

  /* --------------- 60 to 6f --------------- */
  Ctrl | FctKey | 0xc0,		/* (Ctrl) F3 */
  Ctrl | FctKey | 0xc1,		/* (Ctrl) F4 */
  Ctrl | FctKey | 0xc2,		/* (Ctrl) F5 */
  Ctrl | FctKey | 0xc3,		/* (Ctrl) F6 */
  Ctrl | FctKey | 0xc4,		/* (Ctrl) F7 */
  Ctrl | FctKey | 0xc5,		/* (Ctrl) F8 */
  Ctrl | FctKey | 0xc6,		/* (Ctrl) F9 */
  Ctrl | FctKey | 0xc7,		/* (Ctrl) F10 */
  Alt | FctKey | 0xbe,		/* (Alt) F1 */
  Alt | FctKey | 0xbf,		/* (Alt) F2 */
  Alt | FctKey | 0xc0,		/* (Alt) F3 */
  Alt | FctKey | 0xc1,		/* (Alt) F4 */
  Alt | FctKey | 0xc2,		/* (Alt) F5 */
  Alt | FctKey | 0xc3,		/* (Alt) F6 */
  Alt | FctKey | 0xc4,		/* (Alt) F7 */
  Alt | FctKey | 0xc5,		/* (Alt) F8 */

  /* --------------- 70 to 7f --------------- */
  Alt | FctKey | 0xc6,		/* (Alt) F9 */
  Alt | FctKey | 0xc7,		/* (Alt) F10 */
  Ctrl | FctKey | 0x6d,		/* (Ctrl) Sys Rq */
  Ctrl | KeyPad | 4,		/* (Ctrl) Left */
  Ctrl | KeyPad | 6,		/* (Ctrl) Right */
  Ctrl | KeyPad | 1,		/* (Ctrl) End */
  Ctrl | KeyPad | 3,		/* (Ctrl) Page Down */
  Ctrl | KeyPad | 7,		/* (Ctrl) Home */
  Alt | Map | 1,		/* '1' */
  Alt | Map | 2,		/* '2' */
  Alt | Map | 3,		/* '3' */
  Alt | Map | 4,		/* '4' */
  Alt | Map | 5,		/* '5' */
  Alt | Map | 6,		/* '6' */
  Alt | Map | 7,		/* '7' */
  Alt | Map | 8,		/* '8' */

  /* --------------- 80 to 8f --------------- */
  Alt | Map | 9,		/* '9' */
  Alt | Map | 10,		/* '0' */
  Alt | Map | 11,		/* '-' */
  Alt | Map | 12,		/* '=' */
  Ctrl | KeyPad | 9,		/* (Ctrl) Page Up */
  FctKey | 0xc8,		/* F11 */
  FctKey | 0xc9,		/* F12 */
  Shift | FctKey | 0xc8,	/* (Shift) F11 */
  Shift | FctKey | 0xc9,	/* (Shift) F12 */
  Ctrl | FctKey | 0xc8,		/* (Ctrl) F11 */
  Ctrl | FctKey | 0xc9,		/* (Ctrl) F12 */
  Alt | FctKey | 0xc8,		/* (Alt) F11 */
  Alt | FctKey | 0xc9,		/* (Alt) F12 */
  Ctrl | KeyPad | 8,		/* (Ctrl) Up */
  Ctrl | Grey | 2,		/* (Ctrl) Grey - */
  Ctrl | KeyPad | 5,		/* (Ctrl) Keypad 5 */

  /* --------------- 90 to 9f --------------- */
  Ctrl | Grey | 3,		/* (Ctrl) Grey + */
  Ctrl | KeyPad | 2,		/* (Ctrl) Down */
  Ctrl | KeyPad | 0,		/* (Ctrl) Insert */
  Ctrl | KeyPad | 10,		/* (Ctrl) Delete */
  Ctrl | FctKey | 0x09,		/* (Ctrl) Tab */
  Ctrl | Grey | 0,		/* (Ctrl) Grey / */
  Ctrl | Grey | 1,		/* (Ctrl) Grey * */
  Alt | FctKey | 0x50,		/* (Alt) Home */
  Alt | FctKey | 0x52,		/* (Alt) Up */
  Alt | FctKey | 0x55,		/* (Alt) Page Up */
  Ignore,			/* NO KEY */
  Alt | FctKey | 0x51,		/* (Alt) Left */
  Ignore,			/* NO KEY */
  Alt | FctKey | 0x53,		/* (Alt) Right */
  Ignore,			/* NO KEY */
  Alt | FctKey | 0x57,		/* (Alt) End */

  /* --------------- a0 to af --------------- */
  Alt | KeyPad | 2,		/* (Alt) Down */
  Alt | KeyPad | 3,		/* (Alt) Page Down */
  Alt | KeyPad | 0,		/* (Alt) Insert */
  Alt | KeyPad | 10,		/* (Alt) Delete */
  Alt | Grey | 0,		/* (Alt) Grey / */
  Alt | FctKey | 0x09,		/* (Alt) Tab */
  Alt | Grey | 4		/* (Alt) Keypad Enter */
};

/* patch 96.1.29  by K.Fujii */
#define SHIFT98_P 0x01
#define CAPS98_P  0x02
#define KANA98_P  0x04
#define GRPH98_P  0x08
#define CTRL98_P  0x10

/* These bit-positions corresponds to values returned by BIOS */
#define SHIFT_P		0x0003	/* two bits! */
#define CTRL_P		0x0004
#define ALT_P		0x0008
#define SCRLOCK_P	0x0010
#define NUMLOCK_P	0x0020
#define CAPSLOCK_P	0x0040
#define ALT_GR_P	0x0800
#define SUPER_P		0x4000	/* pseudo */
#define HYPER_P		0x8000	/* pseudo */

static int
dos_get_modifiers_at (int *keymask)
{
  __dpmi_regs regs;
  int mask;
  int modifiers = 0;
  
  /* Calculate modifier bits */
  regs.h.ah = extend_kbd ? 0x12 : 0x02;
  __dpmi_int (0x16, &regs);

  if (!extend_kbd)
    {
      mask = regs.h.al & (SHIFT_P | CTRL_P | ALT_P | 
			  SCRLOCK_P | NUMLOCK_P | CAPSLOCK_P);
    }
  else
    {
      mask = regs.h.al & (SHIFT_P |
			  SCRLOCK_P | NUMLOCK_P | CAPSLOCK_P);
  
      /* Do not break international keyboard support.   */
      /* When Keyb.Com is loaded, the right Alt key is  */
      /* used for accessing characters like { and } 	  */
      if (regs.h.ah & 2)		/* Left ALT pressed ? */
	mask |= ALT_P;

      if ((regs.h.ah & 8) != 0)		/* Right ALT pressed ? */
	{
	  mask |= ALT_GR_P;
	  if (dos_hyper_key == 1)
	    {
	      mask |= HYPER_P;
	      modifiers |= hyper_modifier;
	    }
	  else if (dos_super_key == 1)
	    {
	      mask |= SUPER_P;
	      modifiers |= super_modifier;
	    }
	}
      
      if (regs.h.ah & 1)		/* Left CTRL pressed */
	mask |= CTRL_P;

      if (regs.h.ah & 4)	 	/* Right CTRL pressed ? */
	{
	  if (dos_hyper_key == 2)
	    {
	      mask |= HYPER_P;
	      modifiers |= hyper_modifier;
	    }
	  else if (dos_super_key == 2)
	    {
	      mask |= SUPER_P;
	      modifiers |= super_modifier;
	    }
	  else
	    mask |= CTRL_P;
	}
    }

  if (mask & SHIFT_P)
    modifiers |= shift_modifier;
  if (mask & CTRL_P)
    modifiers |= ctrl_modifier;
  if (mask & ALT_P)
    modifiers |= meta_modifier;

  if (keymask)
    *keymask = mask;
  return modifiers;
}

/* patch 96.2.2  by K.Fujii */
static int
dos_get_modifiers_98 (int *keymask)
{
  unsigned char shift_sts;
  int modifier = 0;

  dosmemget (0x53a, 1, &shift_sts);
  if (shift_sts & SHIFT98_P)
    modifier |= shift_modifier;
  if (shift_sts & CTRL98_P)
    modifier |= ctrl_modifier;
  if (shift_sts & GRPH98_P)
    modifier |= meta_modifier;
  if (keymask)
    *keymask = (int) shift_sts;
  return modifier;
}

static (*dos_get_modifiers_fun)(int *keymask);

#define dos_get_modifiers (*dos_get_modifiers_fun)
/* end of patch */

#define NUM_RECENT_DOSKEYS (100)
int recent_doskeys_index;	/* Index for storing next element into recent_doskeys */
int total_doskeys;		/* Total number of elements stored into recent_doskeys */
Lisp_Object recent_doskeys; /* A vector, holding the last 100 keystrokes */

DEFUN ("recent-doskeys", Frecent_doskeys, Srecent_doskeys, 0, 0, 0,
  "Return vector of last 100 keyboard input values seen in dos_rawgetc.\n\
Each input key receives two values in this vector: first the ASCII code,\n\
and then the scan code.")
     ()
{
  Lisp_Object *keys = XVECTOR (recent_doskeys)->contents;
  Lisp_Object val;

  if (total_doskeys < NUM_RECENT_DOSKEYS)
    return Fvector (total_doskeys, keys);
  else
    {
      val = Fvector (NUM_RECENT_DOSKEYS, keys);
      bcopy (keys + recent_doskeys_index,
	     XVECTOR (val)->contents,
	     (NUM_RECENT_DOSKEYS - recent_doskeys_index) * sizeof (Lisp_Object));
      bcopy (keys,
	     XVECTOR (val)->contents + NUM_RECENT_DOSKEYS - recent_doskeys_index,
	     recent_doskeys_index * sizeof (Lisp_Object));
      return val;
    }
}

/* patch 96.2.2  by K.Fujii */
static void
mouse_event ()
{
  struct input_event event;
  int but, press, x, y, ok;

  /* Check for mouse movement *before* buttons.  */
  mouse_check_moved ();

  for (but = 0; but < NUM_MOUSE_BUTTONS; but++)
    {
      for (press = 0; press < 2; press++)
	{
	  if (press)
	    ok = mouse_pressed (but, &x, &y);
	  else
	    ok = mouse_released (but, &x, &y);
	  if (ok)
	    {
	      event.kind = mouse_click;
	      event.code = but;
	      event.modifiers = dos_get_modifiers (0)
		| (press ? down_modifier : up_modifier);
	      event.x = x;
	      event.y = y;
	      XSETFRAME (event.frame_or_window, selected_frame);
	      event.timestamp = event_timestamp ();
	      kbd_buffer_store_event (&event);
	    }
	}
    }
}
/* end of patch */

/* Get a char from keyboard.  Function keys are put into the event queue.  */

int fep_get_mode (void);	/* 96.2.2  by K.Fujii */

static int
dos_rawgetc_at ()
{
  struct input_event event;
  __dpmi_regs regs;
  unsigned char c;
  int sc, code, mask, kp_mode;
  int modifiers;

  
#ifndef HAVE_X_WINDOWS
  SCREEN_SET_CURSOR ();
  mouse_on (); /* 96.2.12  by K.Fujii */
#endif
    
  modifiers = dos_get_modifiers (&mask);
      
  /* The following condition is equivalent to `kbhit ()', except that
     it uses the bios to do its job.  This pleases DESQview/X.  */
  /* patch 96.2.2  by K.Fujii */
  if (ModePCAT () || ! fep_get_mode ())
    {
      regs.h.ah = extend_kbd ? 0x11 : 0x01;
      __dpmi_int (0x16, &regs);
      if (regs.x.flags & 0100) goto mouse_check;
    dosv_bios_key:
      regs.h.ah = extend_kbd ? 0x10 : 0x00;
      __dpmi_int(0x16, &regs);
      c = regs.h.al;
      sc = regs.h.ah;

      total_doskeys += 2;
      XVECTOR (recent_doskeys)->contents[recent_doskeys_index++]
	= make_number (c);
      if (recent_doskeys_index == NUM_RECENT_DOSKEYS)
	recent_doskeys_index = 0;
      XVECTOR (recent_doskeys)->contents[recent_doskeys_index++]
	= make_number (sc);
      if (recent_doskeys_index == NUM_RECENT_DOSKEYS)
	recent_doskeys_index = 0;

#ifndef HAVE_X_WINDOWS
      if (!NILP (Vdos_display_scancodes))
	{
	  char buf[10];
	  sprintf (buf, "%02x:%02x*%04x",
		   (unsigned) (sc&0xff), (unsigned) c, mask);
	  dos_direct_output (screen_size_Y - 2, screen_size_X - 12, buf, 10);
	}
#endif

      if (sc == 0xe0)
	{
	  switch (c)
	    {
	    case 10:		/* Ctrl Grey Enter */
	      code = Ctrl | Grey | 4;
	      break;
	    case 13:		/* Grey Enter */
	      code = Grey | 4;
	      break;
	    case '/':		/* Grey / */
	      code = Grey | 0;
	      break;
	    default:
	      goto mouse_check;
	    };
	  c = 0;
	}
      else
	{
	  /* patch 96.2.10  by K.Fujii */
	  if (sc == 0x73 &&
	      (c == '_' || c == '\\')){
	    return '_';
	  }
	  /* end of patch */
	  if (sc >= (sizeof (ibmpc_translate_map) / sizeof (short)))
	    goto mouse_check;
	  if ((code = ibmpc_translate_map[sc]) == Ignore)
	    goto mouse_check;
	}

      if (c == 0)
	{
	  if (code & Alt)
	    modifiers |= meta_modifier;
	  if (code & Ctrl)
	    modifiers |= ctrl_modifier;
	  if (code & Shift)
	    modifiers |= shift_modifier;
	}
    }
  else
    {
      regs.h.ah = 1;
      __dpmi_int (0x16, &regs);
      if (regs.x.flags & 0100) goto mouse_check;
      sc = (regs.h.ah & 0377);
      c =  (regs.h.al & 0377);
      if ((0x80 <= c && c <= 0x9f) ||
	  (0xe0 <= c && c <= 0xf7))
	{	  
	  regs.h.ah = 6;
	  regs.h.dl = 0377;
	  __dpmi_int (0x21, &regs);
	  if (regs.x.flags & 0100) goto mouse_check;
	  c = (regs.h.al & 0377);
	  if (c == ' ' && (modifiers & ctrl_modifier)) c = 0;
	  else if (c == 8 && ! (modifiers & ctrl_modifier)) c = 0177;
	  code = 0;
	}
      else
	goto dosv_bios_key;
    }

  switch (code & 0xf000)
    {
    case ModFct:
      if (c && !(mask & (SHIFT_P | ALT_P | CTRL_P | HYPER_P | SUPER_P)))
	return c;
      c = 0;		/* Special */
  
    case FctKey:
      if (c != 0)
	return c;
    
    case Special:
      code |= 0xff00;
      break;
  
    case Normal:
      if (sc == 0)
	{
	  if (c == 0)	/* ctrl-break */
	    goto mouse_check;
	  return c;		/* ALT-nnn */
	}
      if (!keyboard_map_all)
	{
	  if (c != ' ')
	    return c;
	  code = c;
	  break;
	}
  
    case Map:
      if (c && !(mask & ALT_P) && !((mask & SHIFT_P) && (mask & CTRL_P)))
	if (!keyboard_map_all)
	  return c;

      code &= 0xff;
      if (mask & ALT_P && code <= 10 && code > 0 && dos_keypad_mode & 0x200)
	mask |= SHIFT_P;	/* ALT-1 => M-! etc. */
  
      if (mask & SHIFT_P)
	{
	  code = keyboard->shifted[code];
	  mask -= SHIFT_P;
	  modifiers &= ~shift_modifier;
	}
      else
	if ((mask & ALT_GR_P) && keyboard->alt_gr && keyboard->alt_gr[code] != ' ')
	  code = keyboard->alt_gr[code];
	else
	  code = keyboard->unshifted[code];
      break;

    case KeyPad:
      code &= 0xff;
      if (c == 0xe0)	/* edit key */
	kp_mode = 3;
      else
	if ((mask & (NUMLOCK_P|CTRL_P|SHIFT_P|ALT_P)) == NUMLOCK_P) /* numlock on */
	  kp_mode = dos_keypad_mode & 0x03;
	else
	  kp_mode = (dos_keypad_mode >> 4) & 0x03;

      switch (kp_mode)
	{
	case 0:
	  if (code == 10 && dos_decimal_point)
	    return dos_decimal_point;
	  return keypad_translate_map[code].char_code;

	case 1:
	  code = 0xff00 | keypad_translate_map[code].keypad_code;
	  break;

	case 2:
	  code = keypad_translate_map[code].meta_code;
	  modifiers = meta_modifier;
	  break;
    
	case 3:
	  code = 0xff00 | keypad_translate_map[code].editkey_code;
	  break;
	}
      break;
  
    case Grey:
      code &= 0xff;
      kp_mode = ((mask & (NUMLOCK_P|CTRL_P|SHIFT_P|ALT_P)) == NUMLOCK_P) ? 0x04 : 0x40;
      if (dos_keypad_mode & kp_mode)
	code = 0xff00 | grey_key_translate_map[code].keypad_code;
      else
	code = grey_key_translate_map[code].char_code;
      break;
    }

 make_event:
  if (code == 0)
    goto mouse_check;
      
  if (code >= 0x100)
    event.kind = non_ascii_keystroke;
  else
    event.kind = ascii_keystroke;
  event.code = code;
  event.modifiers =	modifiers;
  XSETFRAME (event.frame_or_window, selected_frame);
  event.timestamp = event_timestamp ();
  kbd_buffer_store_event (&event);

 mouse_check:
  if (have_mouse > 0)
    mouse_event ();
  return -1;
}

/* patch 94.6.4, 94.7.8, 94.10.8, 96.2.1  by K.Fujii, 94.8.15  by T.Yasuda */
static unsigned short pc98_translate_map [] =
{
  /* ---- 0x00 ~ 0x0f ---- */
  0xff1b,			/* ESC */
  '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '-', '^', '\\',
  0xff08,			/* BS */
  0xff09,			/* TAB */
  /* ---- 0x10 ~ 0x1f ---- */
  'q', 'w', 'e', 'r', 't', 'y', 'u', 'i', 'o', 'p', '@', '[',
  0xff8d,			/* RET */
  'a', 's', 'd',
  /* ---- 0x20 ~ 0x2f ---- */
  'f', 'g', 'h', 'j', 'k', 'l', ';', ':',
  ']', 'z', 'x', 'c', 'v', 'b', 'n', 'm',
  /* ---- 0x30 ~ 0x3f ---- */
  ',', '.', '/', '_', ' ',
  0,				/* XFER */
  0xff56,			/* Roll Up */
  0xff55,			/* Roll Down */
  0xff63,			/* INS */
  0xffff,			/* DEL */
  0xff52,			/* Up */
  0xff51,			/* Left */
  0xff53,			/* Right */
  0xff54,			/* Down */
  0xff50,			/* HOME/CLR */
  0xff6a,			/* HELP */
  /* ---- 0x40 ~ 0x4f ---- */
  0xffad,			/* TenKey - */
  0xffaf,			/* TenKey / */
  0xffb7,			/* TenKey 7 */
  0xffb8,			/* TenKey 8 */
  0xffb9,			/* TenKey 9 */
  0xffaa,			/* TenKey * */
  0xffb4,			/* TenKey 4 */
  0xffb5,			/* TenKey 5 */
  0xffb6,			/* TenKey 6 */
  0xffab,			/* TenKey + */
  0xffb1,			/* TenKey 1 */
  0xffb2,			/* TenKey 2 */
  0xffb3,			/* TenKey 3 */
  0xffbd,			/* TenKey = */
  0xffb0,			/* TenKey 0 */
  0xffa0,			/* TenKey , */
  /* ---- 0x50 ~ 0x5f ---- */
  0xffae,			/* TenKey . */
  0,				/* NFER */
  0xffc8,			/* f.11 */
  0xffc9,			/* f.12 */
  0xffca,			/* f.13 */
  0xffcb,			/* f.14 */
  0xffcc,			/* f.15 */
  0, 0, 0, 0, 0, 0, 0,
  0xff50,			/* HOME */
  0,
  /* 0x60 ~ 0x6f ---- */
  0xff6b,			/* STOP */
  0,				/* COPY */
  0xffbe,			/* f.1 */
  0xffbf,			/* f.2 */
  0xffc0,			/* f.3 */
  0xffc1,			/* f.4 */
  0xffc2,			/* f.5 */
  0xffc3,			/* f.6 */
  0xffc4,			/* f.7 */
  0xffc5,			/* f.8 */
  0xffc6,			/* f.9 */
  0xffc7,			/* f.10 */
  0, 0, 0, 0,
  /* ---- 0x70 ~ 0x7f ---- */
  0,				/* SHIFT */
  0,				/* CAPS */
  0,				/* KANA */
  0,				/* GRPH */
  0,				/* CTRL */
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* ---- 0x80 ~ 0x8f ---- */
  0, 0,
  0xffbe,			/* Shift + f.1 */
  0xffbf,			/* Shift + f.2 */
  0xffc0,			/* Shift + f.3 */
  0xffc1,			/* Shift + f.4 */
  0xffc2,			/* Shift + f.5 */
  0xffc3,			/* Shift + f.6 */
  0xffc4,			/* Shift + f.7 */
  0xffc5,			/* Shift + f.8 */
  0xffc6,			/* Shift + f.9 */
  0xffc7,			/* Shift + f.10 */
  0, 0, 0, 0,
  /* ---- 0x90 ~ 0x9f ---- */
  0, 0,
  0xffbe,			/* Ctrl + f.1 */
  0xffbf,			/* Ctrl + f.2 */
  0xffc0,			/* Ctrl + f.3 */
  0xffc1,			/* Ctrl + f.4 */
  0xffc2,			/* Ctrl + f.5 */
  0xffc3,			/* Ctrl + f.6 */
  0xffc4,			/* Ctrl + f.7 */
  0xffc5,			/* Ctrl + f.8 */
  0xffc6,			/* Ctrl + f.9 */
  0xffc7,			/* Ctrl + f.10 */
  0, 0, 0, 0,
  /* ---- 0xa0 ~ 0xaf ---- */
  0,
  0,				/* Shift + NFER */
  0, 0, 0,
  0,				/* Shift + XFER */
  0, 0, 0, 0, 0, 0, 0, 0,
  0xff50,			/* Shift + HOME/CLR */
  0,
  /* ---- 0xb0 ~ 0xbf ---- */
  0,
  0,				/* Ctrl + NFER */
  0, 0, 0,
  0,				/* Ctrl + XFER */
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* ---- 0xc0 ~ 0xcf ---- */
  0, 0,
  0xffc8,			/* Shift + f.11 */
  0xffc9,			/* Shift + f.12 */
  0xffca,			/* Shift + f.13 */
  0xffcb,			/* Shift + f.14 */
  0xffcc,			/* Shift + f.15 */
  0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* ---- 0xd0 ~ 0xd6 ---- */
  0, 0,
  0xffc8,			/* Ctrl + f.11 */
  0xffc9,			/* Ctrl + f.12 */
  0xffca,			/* Ctrl + f.13 */
  0xffcb,			/* Ctrl + f.14 */
  0xffcc,			/* Ctrl + f.15 */
};

static unsigned short pc98_fkey_translate_map [] =
{
  0xffbe,			/* f.1 */
  0xffbf,			/* f.2 */
  0xffc0,			/* f.3 */
  0xffc1,			/* f.4 */
  0xffc2,			/* f.5 */
  0xffc3,			/* f.6 */
  0xffc4,			/* f.7 */
  0xffc5,			/* f.8 */
  0xffc6,			/* f.9 */
  0xffc7,			/* f.10 */
  0xffbe,			/* Shift + f.1 */
  0xffbf,			/* Shift + f.2 */
  0xffc0,			/* Shift + f.3 */
  0xffc1,			/* Shift + f.4 */
  0xffc2,			/* Shift + f.5 */
  0xffc3,			/* Shift + f.6 */
  0xffc4,			/* Shift + f.7 */
  0xffc5,			/* Shift + f.8 */
  0xffc6,			/* Shift + f.9 */
  0xffc7,			/* Shift + f.10 */
  0xff56,			/* Roll Up */
  0xff55,			/* Roll Down */
  0xff63,			/* INS */
  0xffff,			/* DEL */
  0xff52,			/* Up */
  0xff51,			/* Left */
  0xff53,			/* Right */
  0xff54,			/* Down */
  0xff50,			/* HOME */
  0xff6a,			/* HELP */
  0xff50,			/* CLR */
  0xffc8,			/* f.11 */
  0xffc9,			/* f.12 */
  0xffca,			/* f.13 */
  0xffcb,			/* f.14 */
  0xffcc,			/* f.15 */
  0xffc8,			/* Shift + f.11 */
  0xffc9,			/* Shift + f.12 */
  0xffca,			/* Shift + f.13 */
  0xffcb,			/* Shift + f.14 */
  0xffcc,			/* Shift + f.15 */
  0xffbe,			/* Ctrl + f.1 */
  0xffbf,			/* Ctrl + f.2 */
  0xffc0,			/* Ctrl + f.3 */
  0xffc1,			/* Ctrl + f.4 */
  0xffc2,			/* Ctrl + f.5 */
  0xffc3,			/* Ctrl + f.6 */
  0xffc4,			/* Ctrl + f.7 */
  0xffc5,			/* Ctrl + f.8 */
  0xffc6,			/* Ctrl + f.9 */
  0xffc7,			/* Ctrl + f.10 */
  0xffc8,			/* Ctrl + f.11 */
  0xffc9,			/* Ctrl + f.12 */
  0xffca,			/* Ctrl + f.13 */
  0xffcb,			/* Ctrl + f.14 */
  0xffcc,			/* Ctrl + f.15 */
};

static unsigned short pc98_meta_shift_map [] =
{
  /* ---- 0x00 ~ 0x0f ---- */
  0xff1b,			/* ESC */
  '!', '"', '#', '$', '%', '&',  39, '(', ')', '0', '=', '`', '|',
  0xff08,			/* BS */
  0xff09,			/* TAB */
  /* ---- 0x10 ~ 0x1f ---- */
  'Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P', '~', '{',
  0xff8d,			/* RET */
  'A', 'S', 'D',
  /* ---- 0x20 ~ 0x2f ---- */
  'F', 'G', 'H', 'J', 'K', 'L', '+', '*',
  '}', 'Z', 'X', 'C', 'V', 'B', 'N', 'M',
  /* ---- 0x30 ~ 0x3f ---- */
  '<', '>', '?', '_', ' ',
  0,				/* XFER */
  0xff56,			/* Roll Up */
  0xff55,			/* Roll Down */
  0xff63,			/* INS */
  0xffff,			/* DEL */
  0xff52,			/* Up */
  0xff51,			/* Left */
  0xff53,			/* Right */
  0xff54,			/* Down */
  0xff50,			/* HOME/CLR */
  0xff6a,			/* HELP */
  /* ---- 0x40 ~ 0x4f ---- */
  0xffad,			/* TenKey - */
  0xffaf,			/* TenKey / */
  0xffb7,			/* TenKey 7 */
  0xffb8,			/* TenKey 8 */
  0xffb9,			/* TenKey 9 */
  0xffaa,			/* TenKey * */
  0xffb4,			/* TenKey 4 */
  0xffb5,			/* TenKey 5 */
  0xffb6,			/* TenKey 6 */
  0xffab,			/* TenKey + */
  0xffb1,			/* TenKey 1 */
  0xffb2,			/* TenKey 2 */
  0xffb3,			/* TenKey 3 */
  0xffbd,			/* TenKey = */
  0xffb0,			/* TenKey 0 */
  0xffa0,			/* TenKey , */
  /* ---- 0x50 ---- */
  0xffae,			/* TenKey . */
};

static int
dos_rawgetc_98 (void)
{
  __dpmi_regs regs;
  struct input_event event;
  int modif;
  unsigned c, sc, code;
  unsigned char shift_sts;

  code = 0;

#ifndef HAVE_X_WINDOWS
  SCREEN_SET_CURSOR ();
  mouse_on ();  /* 96.2.12  by K.Fujii */
#endif

  modif = dos_get_modifiers_98 (0);
  regs.h.ah = 1;
  __dpmi_int (0x18, &regs);

  if (regs.h.bh && (((modif & ctrl_modifier) && regs.h.al == 0x20) ||
		    ! fep_get_mode ()))
    {
      regs.h.ah = 0;
      __dpmi_int (0x18, &regs);
      sc = regs.h.ah & 0377;
      c  = regs.h.al & 0377;

      /* Grph + ? */
      if ((c >= 0x80 && c <= 0x9f) ||
	  (c >= 0xe0 && c <= 0xf7))
	{
	  modif |= meta_modifier;
	  code = (modif & shift_modifier) ? pc98_meta_shift_map [sc]
	    : pc98_translate_map [sc];
	  modif &= ~shift_modifier;
	}
      else if ((sc != 0x1a && ! c) ||
	       /* Tenkeys + Shift(Ctrl), RET + Shift(Ctrl) */
	       (((sc >= 0x40 && sc <= 0x51) || sc == 0x1c) &&
		(modif & (shift_modifier || ctrl_modifier))) ||
	       /* ESC, BS, TAB */
	       sc == 0x00 || sc == 0x0e ||
	       sc == 0x0f)
	{
	  if (sc < sizeof (pc98_translate_map) / sizeof (unsigned short))
	    code = pc98_translate_map [sc];
	  if (! code) goto mouse_check;
	}
      /* Ctrl + SP */
      else if (c == ' ' && (modif & ctrl_modifier))
	c = 0, modif &= ~ctrl_modifier;
    }
  else
    {
      regs.h.ah = 6;
      regs.h.dl = 0377;
      __dpmi_int (0x21, &regs);
      if (regs.x.flags & 0100) goto mouse_check;
      sc = c = regs.h.al & 0377;
      if (c == 0377)	/* Function Key. */
	{
	  regs.h.ah = 7;
	  __dpmi_int (0x21, &regs);
	  c = regs.h.al & 0377;
	  if (c <= (sizeof(pc98_fkey_translate_map) /
		    sizeof(unsigned short)))
	    code = pc98_fkey_translate_map [c - 1];
	  if (code == 0) goto mouse_check;
	}
      else
	{
	  if (c == ' ' && (modif & ctrl_modifier)) c = 0; /* CTRL + SP */
	  else if (c == 8 && ! (modif & ctrl_modifier)) code = 0xff08; /* BS */
	  modif = 0;
	}
    }

  total_doskeys += 2;
  XVECTOR (recent_doskeys)->contents[recent_doskeys_index++]
    = make_number (c);
  if (recent_doskeys_index == NUM_RECENT_DOSKEYS)
    recent_doskeys_index = 0;
  XVECTOR (recent_doskeys)->contents[recent_doskeys_index++]
    = make_number (sc);
  if (recent_doskeys_index == NUM_RECENT_DOSKEYS)
    recent_doskeys_index = 0;

  if (code ||
      (modif & meta_modifier) ||
      ((modif & ctrl_modifier) &&
       (modif & shift_modifier)))
    {
      if (code & 0xff00)
	event.kind = non_ascii_keystroke;
      else
	{
	  if (! code) code = c;
	  code &= 0377;
	  event.kind = ascii_keystroke;
	}
      event.code = code;
      event.modifiers = modif;
      XSETFRAME (event.frame_or_window, selected_frame);
      event.timestamp = event_timestamp ();
      kbd_buffer_store_event (&event);
    }
  else
    return c;
 mouse_check:
  if (have_mouse > 0)
    mouse_event ();
  return -1;
}

static int (*dos_rawgetc_fun) (void);

#define dos_rawgetc (*dos_rawgetc_fun)
/* end of patch */

static int prev_get_char = -1;

/* Return 1 if a key is ready to be read without suspending execution.  */
dos_keysns ()
{
  if (prev_get_char != -1)
    return 1;
  else
    return ((prev_get_char = dos_rawgetc ()) != -1);
}

/* Read a key.  Return -1 if no key is ready.  */
dos_keyread ()
{
  if (prev_get_char != -1)
    {
      int c = prev_get_char;
      prev_get_char = -1;
      return c;
    }
  else
    return dos_rawgetc ();
}
#endif /* GO32WIN */

#ifndef HAVE_X_WINDOWS
/* See xterm.c for more info.  */
void
pixel_to_glyph_coords (f, pix_x, pix_y, x, y, bounds, noclip)
     FRAME_PTR f;
     register int pix_x, pix_y;
     register int *x, *y;
     void /* XRectangle */ *bounds;
     int noclip;
{
  if (bounds) abort ();

  /* Ignore clipping.  */

  *x = pix_x;
  *y = pix_y;
}

void
glyph_to_pixel_coords (f, x, y, pix_x, pix_y)
     FRAME_PTR f;
     register int x, y;
     register int *pix_x, *pix_y;
{
  *pix_x = x;
  *pix_y = y;
}

#ifndef GO32WIN
/* Simulation of X's menus.  Nothing too fancy here -- just make it work
   for now.

   Actually, I don't know the meaning of all the parameters of the functions
   here -- I only know how they are called by xmenu.c.  I could of course
   grab the nearest Xlib manual (down the hall, second-to-last door on the
   left), but I don't think it's worth the effort.  */

static XMenu *
IT_menu_create ()
{
  XMenu *menu;

  menu = (XMenu *) xmalloc (sizeof (XMenu));
  menu->allocated = menu->count = menu->panecount = menu->width = 0;
  return menu;
}

/* Allocate some (more) memory for MENU ensuring that there is room for one
   for item.  */

static void
IT_menu_make_room (XMenu *menu)
{
  if (menu->allocated == 0)
    {
      int count = menu->allocated = 10;
      menu->text = (unsigned char **) xmalloc (count * sizeof (char *));
      menu->submenu = (XMenu **) xmalloc (count * sizeof (XMenu *));
      menu->panenumber = (int *) xmalloc (count * sizeof (int));
    }
  else if (menu->allocated == menu->count)
    {
      int count = menu->allocated = menu->allocated + 10;
      menu->text
	= (unsigned char **) xrealloc (menu->text, count * sizeof (char *));
      menu->submenu
	= (XMenu **) xrealloc (menu->submenu, count * sizeof (XMenu *));
      menu->panenumber
	= (int *) xrealloc (menu->panenumber, count * sizeof (int));
    }
}

/* Search the given menu structure for a given pane number.  */

static XMenu *
IT_menu_search_pane (XMenu *menu, int pane)
{
  int i;
  XMenu *try;

  for (i = 0; i < menu->count; i++)
    if (menu->submenu[i])
      {
	if (pane == menu->panenumber[i])
	  return menu->submenu[i];
	if ((try = IT_menu_search_pane (menu->submenu[i], pane)))
	  return try;
      }
  return (XMenu *) 0;
}

/* Determine how much screen space a given menu needs.  */

static void
IT_menu_calc_size (XMenu *menu, int *width, int *height)
{
  int i, h2, w2, maxsubwidth, maxheight;

  maxsubwidth = 0;
  maxheight = menu->count;
  for (i = 0; i < menu->count; i++)
    {
      if (menu->submenu[i])
	{
	  IT_menu_calc_size (menu->submenu[i], &w2, &h2);
	  if (w2 > maxsubwidth) maxsubwidth = w2;
	  if (i + h2 > maxheight) maxheight = i + h2;
	}
    }
  *width = menu->width + maxsubwidth;
  *height = maxheight;
}

/* Display MENU at (X,Y) using FACES. */

/* patch 96.2.12  by K.Fuijii */
static INLINE int
IT_revkanji (unsigned short *kp, int limit)
{
  int i;

  if (! iskanji (*kp & 0xff)) return 0;
  kp--;
  for (i = 0; ++i < limit && iskanji (*kp & 0xff); kp--)
    ;
  return (i & 1);
}
/* end of patch */

static void
IT_menu_display (XMenu *menu, int y, int x, int *faces,
		 unsigned char *screen_bihind) /* 96.2.12  by K.Fujii */
{
  int i, j, face, width;
  GLYPH *text, *p;
  unsigned char *q;
  int mx, my;
  int enabled, mousehere;
  int row, col;
  /* patch 96.2.12, 96.2.19  by K.Fujii */
  unsigned short *bihindp = (unsigned short *) screen_bihind;
  unsigned c;
  /*end of patch */

  width = menu->width;
  text = (GLYPH *) xmalloc ((width + 2) * sizeof (GLYPH));
  ScreenGetCursor (&row, &col);
  mouse_get_xy (&mx, &my);
  IT_update_begin ();
  /* patch 962.12  by K.Fujii */
  bihindp += (ScreenGetCols () * y) + x;
  screen_bihind = (unsigned char *) bihindp;
  /* end of patch */
  for (i = 0; i < menu->count; i++)
    {
      /* patch 96.2.12  by K.Fujii */
      if (IT_revkanji (bihindp - 1, x))
	ScreenPutChar (' ', screen_bihind [-1], x - 1, y + i);
      /* end of patch */
      IT_cursor_to (y + i, x);
      enabled
	= (!menu->submenu[i] && menu->panenumber[i]) || (menu->submenu[i]);
      mousehere = (y + i == my && x <= mx && mx < x + width + 2);
      face = faces[enabled + mousehere * 2];
      p = text;
      *p++ = FAST_MAKE_GLYPH (' ', face);
      for (j = 0, q = menu->text[i]; *q; j++) { /* patch 96.2.19  by K.Fujii */
	c = *q++;
	if (LC_P (c)) {
	  int c_dir;
	  int c_width = char_width [c];
	  int c_bytes = char_bytes [c];

	  if ((c_dir = char_direction[c]) == DIRECTION_UNDEFINED)
	    c_dir = char_direction[*q];
	  c = STRtoCHAR(q - 1, c_bytes);
	  *p++ = FAST_MAKE_GLYPH (c, face);
	  c |= GLYPH_CTL_COLUMN2;
	  while (c_width-- > 1) {
	    *p++ = FAST_MAKE_GLYPH (c, face);
	    j++;
	  }
	  q += c_bytes - 1;
	} else {
	nongraphic:
	  *p++ = FAST_MAKE_GLYPH (c, face);
	}
      }
      /* end of patch */
      for (; j < width; j++)
	*p++ = FAST_MAKE_GLYPH (' ', face);
      *p++ = FAST_MAKE_GLYPH (menu->submenu[i] ? 16 : ' ', face);
      IT_write_glyphs (text, width + 2);
      /* patch 96.2.12  by K.Fujii */
      if (IT_revkanji (bihindp + ((p - 1) - text), x + ((p - 1) - text)))
	ScreenPutChar (' ', screen_bihind[(p - text) * 2 + 1],
		       x + (p - text), y + i);
      bihindp += ScreenGetCols ();
      screen_bihind = (unsigned char *) bihindp;
      /* end of patch */
    }
  IT_update_end ();
  IT_cursor_to (row, col);
  xfree (text);
}

/* --------------------------- X Menu emulation ---------------------- */

/* Create a brand new menu structure.  */

XMenu *
XMenuCreate (Display *foo1, Window foo2, char *foo3)
{
  return IT_menu_create ();
}

/* Create a new pane and place it on the outer-most level.  It is not
   clear that it should be placed out there, but I don't know what else
   to do.  */

int
XMenuAddPane (Display *foo, XMenu *menu, char *txt, int enable)
{
  int len;

  if (!enable)
    abort ();

  IT_menu_make_room (menu);
  menu->submenu[menu->count] = IT_menu_create ();
  menu->text[menu->count] = txt;
  menu->panenumber[menu->count] = ++menu->panecount;
  menu->count++;
  if ((len = strlen (txt)) > menu->width)
    menu->width = len;
  return menu->panecount;
}

/* Create a new item in a menu pane.  */

int
XMenuAddSelection (Display *bar, XMenu *menu, int pane,
		   int foo, char *txt, int enable)
{
  int len;

  if (pane)
    if (!(menu = IT_menu_search_pane (menu, pane)))
      return XM_FAILURE;
  IT_menu_make_room (menu);
  menu->submenu[menu->count] = (XMenu *) 0;
  menu->text[menu->count] = txt;
  menu->panenumber[menu->count] = enable;
  menu->count++;
  if ((len = strlen (txt)) > menu->width)
    menu->width = len;
  return XM_SUCCESS;
}

/* Decide where the menu would be placed if requested at (X,Y).  */

void
XMenuLocate (Display *foo0, XMenu *menu, int foo1, int foo2, int x, int y,
	     int *ulx, int *uly, int *width, int *height)
{
  if (menu->count == 1 && menu->submenu[0])
      /* Special case: the menu consists of only one pane.  */
    IT_menu_calc_size (menu->submenu[0], width, height);
  else
    IT_menu_calc_size (menu, width, height);
  *ulx = x + 1;
  *uly = y;
  *width += 2;
}

struct IT_menu_state
{
  void *screen_behind;
  XMenu *menu;
  int pane;
  int x, y;
};


/* Display menu, wait for user's response, and return that response.  */

int
XMenuActivate (Display *foo, XMenu *menu, int *pane, int *selidx,
	       int x0, int y0, unsigned ButtonMask, char **txt)
{
  struct IT_menu_state *state;
  int statecount;
  int x, y, i, b;
  int screensize;
  int faces[4], selectface;
  int leave, result, onepane;

  /* Just in case we got here without a mouse present...  */
  if (have_mouse <= 0)
    return XM_IA_SELECT;

  state = alloca (menu->panecount * sizeof (struct IT_menu_state));
  screensize = screen_size * 2;
  faces[0]
    = compute_glyph_face (&the_only_frame,
			  face_name_id_number
			  (&the_only_frame,
			   intern ("msdos-menu-passive-face")),
			  0);
  faces[1]
    = compute_glyph_face (&the_only_frame,
			  face_name_id_number
			  (&the_only_frame,
			   intern ("msdos-menu-active-face")),
			  0);
  selectface
    = face_name_id_number (&the_only_frame, intern ("msdos-menu-select-face"));
  faces[2] = compute_glyph_face (&the_only_frame, selectface, faces[0]);
  faces[3] = compute_glyph_face (&the_only_frame, selectface, faces[1]);

  statecount = 1;
  state[0].menu = menu;
  mouse_off ();
  ScreenRetrieve (state[0].screen_behind = xmalloc (screensize));
  if ((onepane = menu->count == 1 && menu->submenu[0]))
    {
      menu->width = menu->submenu[0]->width;
      state[0].menu = menu->submenu[0];
    }
  else
    {
      state[0].menu = menu;
    }
  state[0].x = x0 - 1;
  state[0].y = y0;
  state[0].pane = onepane;

  mouse_last_x = -1;  /* A hack that forces display.  */
  leave = 0;
  while (!leave)
    {
      mouse_on ();
      mouse_check_moved ();
      if (selected_frame->mouse_moved)
	{
	  selected_frame->mouse_moved = 0;
	  result = XM_IA_SELECT;
	  mouse_get_xy (&x, &y);
	  for (i = 0; i < statecount; i++)
	    if (state[i].x <= x && x < state[i].x + state[i].menu->width + 2)
	      {
		int dy = y - state[i].y;
		if (0 <= dy && dy < state[i].menu->count)
		  {
		    if (!state[i].menu->submenu[dy])
		      if (state[i].menu->panenumber[dy])
			result = XM_SUCCESS;
		      else
			result = XM_IA_SELECT;
		    *pane = state[i].pane - 1;
		    *selidx = dy;
		    /* We hit some part of a menu, so drop extra menues that
		       have been opened.  That does not include an open and
		       active submenu.  */
		    if (i != statecount - 2
			|| state[i].menu->submenu[dy] != state[i+1].menu)
		      while (i != statecount - 1)
			{
			  statecount--;
			  mouse_off ();
			  ScreenUpdate (state[statecount].screen_behind);
			  xfree (state[statecount].screen_behind);
			}
		    if (i == statecount - 1 && state[i].menu->submenu[dy])
		      {
			IT_menu_display (state[i].menu,
					 state[i].y,
					 state[i].x,
					 faces,
					 (unsigned char *) state[i].screen_behind); /* 96.2.12  by K.Fujii */
			state[statecount].menu = state[i].menu->submenu[dy];
			state[statecount].pane = state[i].menu->panenumber[dy];
			mouse_off ();
			ScreenRetrieve (state[statecount].screen_behind
					= xmalloc (screensize));
			state[statecount].x
			  = state[i].x + state[i].menu->width + 2;
			state[statecount].y = y;
			statecount++;			  
		      }
		  }
	      }
	  IT_menu_display (state[statecount - 1].menu,
			   state[statecount - 1].y,
			   state[statecount - 1].x,
			   faces,
			   (unsigned char *) state[statecount - 1].screen_behind); /* 96.2.12  by K.Fujii */
	}
      for (b = 0; b < mouse_button_count; b++)
	{
	  (void) mouse_pressed (b, &x, &y);
	  if (mouse_released (b, &x, &y))
	    leave = 1;
	}
    }

  mouse_off ();
  ScreenUpdate (state[0].screen_behind);
  while (statecount--)
    xfree (state[statecount].screen_behind);
  return result;
}

/* Dispose of a menu.  */

void
XMenuDestroy (Display *foo, XMenu *menu)
{
  int i;
  if (menu->allocated)
    {
      for (i = 0; i < menu->count; i++)
	if (menu->submenu[i])
	  XMenuDestroy (foo, menu->submenu[i]);
      xfree (menu->text);
      xfree (menu->submenu);
      xfree (menu->panenumber);
    }
  xfree (menu);
}

int
x_pixel_width (struct frame *f)
{
  return FRAME_WIDTH (f);
}

int
x_pixel_height (struct frame *f)
{
  return FRAME_HEIGHT (f);
}
#endif /* GO32WIN */
#endif /* !HAVE_X_WINDOWS */

/* ----------------------- DOS / UNIX conversion --------------------- */

/* 95.1.24  by K.Fujii */
static void
check_path_internal (unsigned char *src, unsigned char *dst)
{
  unsigned char *p1, *p2;
  unsigned cc;
  int length;
  int extension;
  int env_path;

#define MAX_NAME_LENGTH 8
#define MAX_EXTENSION_LENGTH 3
#define NON_EXTENSION 0
#define IN_EXTENSION 1
#define MULTI_EXTENSION 2

  length = MAX_NAME_LENGTH;
  extension = NON_EXTENSION;
  env_path = 0;

  p1 = (unsigned char *)index (src, '=');
  if (p1) {
    p1++;
    env_path = 1;
  } else
    p1 = src;
  p2 = dst;

 restart:

  if (p1[1] == ':') {
    if ((*p1 >= 'A' && *p1 <= 'Z')
	|| (*p1 >= 'a' && *p1 <= 'z')) {
      *p2++ = (*p1++) | 0x20;
      *p2++ = *p1++;
    } else goto fatal;
  }

  while (*p1) {
    cc = *p1++;

    if (length <= 0) {
      if (cc == '.') goto start_extension;
      if (cc == '/' || cc == '\\') goto path_punctation;
      if (cc == ';') goto env_path_punct;
      continue;
    }

#ifdef MCPATH
    if (LC_P (cc)) {
      if (cc == LCJP || cc == LCJPOLD) {
	if (length >= 2 && extension != MULTI_EXTENSION) {
	  *p2++ = cc;
	  *p2++ = *p1++;
	  *p2++ = *p1++;
	  length -= 2;
	} else length = 0;
	continue;
      } else if (cc == LCKANA) {
	*p2++ = cc;
	*p2++ = *p1++;
	length--;
	continue;
      }
    }
#endif /* MCPATH */

    switch (cc) {
    case '/':
    case '\\':
    path_punctation:
      extension = NON_EXTENSION;
      length = MAX_NAME_LENGTH + 1;
      cc = '/';
      break;

    case '.':
    start_extension:
      if (extension == NON_EXTENSION) {
	if (*p1 == '.') {
	  *p2++ = cc;
	  *p2++ = *p1++;
	  continue;
	} else {
	  extension = IN_EXTENSION;
	  length = MAX_EXTENSION_LENGTH + 1;
	}
      } else {
	extension = MULTI_EXTENSION;
	length = 0;
	continue;
      }
      break;

      /* patch 94.2.16  by K.Fujii */
    case ';':
    env_path_punct:
      *p2++ = ';';
      length = MAX_NAME_LENGTH;
      extension = NON_EXTENSION;
      env_path = 1;
      goto restart;

    case ':':
      if ((unsigned char *)(src + 2) < p1) {
	if (!env_path) {
	  p2 = dst;
	  *p2++ = p1[-2] | 0x20;
	}
	length = MAX_NAME_LENGTH;
	extension = NON_EXTENSION;
      }
      break;
      /* end of patch */

    case 'A': case 'B': case 'C': case 'D': case 'E':
    case 'F': case 'G': case 'H': case 'I': case 'J':
    case 'K': case 'L': case 'M': case 'N': case 'O':
    case 'P': case 'Q': case 'R': case 'S': case 'T':
    case 'U': case 'V': case 'W': case 'X': case 'Y':
    case 'Z':
      cc |= 040;

    default:
      break;
    }
    *p2++ = cc;
    length--;
  }
 fatal:
  *p2 = '\0';
}
/* end of patch */

/* Destructively turn backslashes into slashes.  */

void
dostounix_filename (p)
     register char *p;
{
#ifdef CHECK_PATH  /* 93.8.14, 94.9.22  by K.Fujii */
  extern int inhibit_check_path;
#if defined (__DJGPP__) && __DJGPP__ > 1
  int use_lfn = _USE_LFN;
#endif

  if (
#if defined (__DJGPP__) && __DJGPP__ > 1
      ! use_lfn &&
#endif
      ! inhibit_check_path) {
    check_path_internal ((unsigned char *) p, (unsigned char *) p);
  } else
#endif
    {
      while (*p)
	{
	  if (*p == '\\')
	    *p = '/';
	  else if (
#if defined (__DJGPP__) && __DJGPP__ > 1
		   ! use_lfn &&
#endif
		   *p >= 'A' && *p <= 'Z')
	    *p |= 0x20;
	  p++;
	}
    }
}

/* patch 94.11.13 by K.Fujii */
Lisp_Object
truncate_path (Lisp_Object path)
{
#if __DJGPP__ > 1
  int use_lfn = _USE_LFN;
#endif

  if (
#if defined (__DJGPP__) && __DJGPP__ > 1
      ! use_len &&
#endif
      STRINGP (path))
    {
      unsigned char *ip = XSTRING (path)->data;
      unsigned char *buf
	= (unsigned char *) alloca (XSTRING (path)->size + 1);

      check_path_internal (ip, buf);
      path = build_string (buf);
    }
  return path;
}
/* end of patch */

/* Destructively turn slashes into backslashes.  */

void
unixtodos_filename (p)
     register char *p;
{
  while (*p)
    {
      if (*p == '/')
	*p = '\\';
      p++;
    }
}

#ifndef MCPATH
/* Get the default directory for a given drive.  0=def, 1=A, 2=B, ...  */

int
getdefdir (drive, dst)
     int drive;
     char *dst;
{
  __dpmi_regs regs;

  *dst++ = '/';
  regs.h.dl = drive;
  regs.x.si = (int) dst;
#if defined (__DJGPP__) && __DJGPP__ > 1
  if (_crt0_startup_flag & _CRT0_FLAG_NO_LFN)
    regs.h.ah = 0x47;
  else
#endif
    regs.x.ax = 0x7147;
  __dpmi_int (0x21, &regs);
  return !(regs.x.flags & 1);
}
#endif

#if 0
/* Remove all CR's that are followed by a LF.  */

int
crlf_to_lf (n, buf)
     register int n;
     register unsigned char *buf;
{
  unsigned char *np = buf;
  unsigned char *startp = buf;
  unsigned char *endp = buf + n;
  unsigned char c;

  if (n == 0)
    return n;
  while (buf < endp - 1)
    {
      if (*buf == 0x0d)
	{
	  if (*(++buf) != 0x0a)
	    *np++ = 0x0d;
	}
      else
	*np++ = *buf++;
    }
  if (buf < endp)
    *np++ = *buf++;
  return np - startp;
}
#endif

/* The Emacs root directory as determined by init_environment.  */

static char emacsroot[MAXPATHLEN];

#ifdef MCPATH  /* 96.3.13  by K.Fujii */
unsigned char *encode_path (unsigned char*, unsigned char*, int, int);
#endif

char *
rootrelativepath (rel)
     char *rel;
{
  static char result[MAXPATHLEN + 10];

  strcpy (result, emacsroot);
  strcat (result, "/");
  strcat (result, rel);
  return result;
}

/* Define a lot of environment variables if not already defined.  Don't
   remove anything unless you know what you're doing -- lots of code will
   break if one or more of these are missing.  */

void
init_environment (argc, argv, skip_args)
     int argc;
     char **argv;
     int skip_args;
{
  char *s, *t, *root;
  int len;

  /* Find our root from argv[0].  Assuming argv[0] is, say,
     "c:/emacs/bin/emacs.exe" our root will be "c:/emacs".  */
  if ((s = getenv ("EMACS")) != 0)
    {
      len = strlen (s);
      root = alloca (len + 20);
      strcpy (root, s);
      dostounix_filename (root);
    }
  else
    {
      unsigned char *tem;

      len = strlen (argv[0]);
#ifdef MCPATH  /* 96.3.13  by K.Fujii */
      if (initialized) {
	tem = encode_path (argv[0], alloca (len * 3 + 256), len * 3 + 256, 1);
	len = strlen (tem);
      } else {
#endif
	tem = (alloca (len + 20));
	strcpy (tem, argv[0]);
#ifdef MCPATH
      }
#endif
      root = alloca (len + 20);
      dostounix_filename (tem);
      strcpy (root, tem);

      while (len > 0 && root[len] != '/' && root[len] != ':')
	len--;
      root[len] = '\0';
      if (len > sizeof (EMACS_ROOT_BIN) &&
	  ! strcmp (root + len - sizeof (EMACS_ROOT_BIN), EMACS_ROOT_BIN))
	root[len - 4] = '\0';
      else
	s = (MachineDOSV () ? EMACS_ROOT_PATH_AT : EMACS_ROOT_PATH_98);
    }

  len = strlen (root);
  strcpy (emacsroot, root);

  /* We default HOME to our root.  */
  setenv ("HOME", root, 0);

  /* We default EMACSPATH to root + "/bin".  */
  strcpy (root + len, "/bin");
  setenv ("EMACSPATH", root, 0);

  /* I don't expect anybody to ever use other terminals so the internal
     terminal is the default.  */
  /* patch 94.7.8, 95.9.25  by K.Fujii, 94.8.15 by T.Yasuda */
  {
    char *term_type;

#ifdef GO32WIN  /* 95.3.26  by K.Fujii */
    term_type = "go32win";
#else
    if (MachinePc98 ()) /* PC-98*1 */
      term_type = "internal98";
    else			/* DOS/V */
      term_type = "internal";
#endif
    setenv ("TERM", term_type, 1);
  }

#ifdef HAVE_X_WINDOWS
  /* Emacs expects DISPLAY to be set.  */
  setenv ("DISPLAY", "unix:0.0", 0);
#endif

  /* SHELL is a bit tricky -- COMSPEC is the closest we come, but we must
     downcase it and mirror the backslashes.  */
  s = getenv ("COMSPEC");
  if (!s) s = MachineDOSV () ? "c:/command.com" : "a:/command.com";
  t = alloca (strlen (s) + 1);
  strcpy (t, s);
  dostounix_filename (t);
  setenv ("SHELL", t, 0);

  /* PATH is also downcased and backslashes mirrored.  */
  s = getenv ("PATH");
  if (!s) s = "";
  t = alloca (strlen (s) + 3);
  /* Current directory is always considered part of MsDos's path but it is
     not normally mentioned.  Now it is.  */
  strcat (strcpy (t, ".;"), s);
  dostounix_filename (t);
  setenv ("PATH", t, 1);

  /* In some sense all dos users have root privileges, so...  */
  setenv ("USER", "root", 0);
  setenv ("NAME", getenv ("USER"), 0);

  /* Time zone determined from country code.  To make this possible, the
     country code may not span more than one time zone.  In other words,
     in the USA, you lose.  */
  if (!getenv ("TZ"))
    switch (dos_country_code)
      {
      case 31:			/* Belgium */
      case 32:			/* The Netherlands */
      case 33:			/* France */
      case 34:			/* Spain */
      case 36:			/* Hungary */
      case 38:			/* Yugoslavia (or what's left of it?) */
      case 39:			/* Italy */
      case 41:			/* Switzerland */
      case 42:			/* Tjekia */
      case 45:			/* Denmark */
      case 46:			/* Sweden */
      case 47:			/* Norway */
      case 48:			/* Poland */
      case 49:			/* Germany */
	/* Daylight saving from last Sunday in March to last Sunday in
	   September, both at 2AM.  */
	setenv ("TZ", "MET-01METDST-02,M3.5.0/02:00,M9.5.0/02:00", 0);
	break;
      case 44:			/* United Kingdom */
      case 351:			/* Portugal */
      case 354:			/* Iceland */
	setenv ("TZ", "GMT+00", 0);
	break;
      case 81:			/* Japan */
      case 82:			/* Korea */
	setenv ("TZ", "JST-09", 0);
	break;
      case 90:			/* Turkey */
      case 358:			/* Finland */
	setenv ("TZ", "EET-02", 0);
	break;
      case 972:			/* Israel */
	/* This is an approximation.  (For exact rules, use the
	   `zoneinfo/israel' file which comes with DJGPP, but you need
	   to install it in `/usr/share/zoneinfo/' directory first.)  */
	setenv ("TZ", "IST-02IDT-03,M4.1.6/00:00,M9.5.6/01:00", 0);
	break;
      }
  init_gettimeofday ();
}



static int break_stat;	 /* BREAK check mode status.	*/
static int stdin_stat;	 /* stdin IOCTL status.		*/

/* These must be global.  */
#ifndef GO32WIN
static _go32_dpmi_seginfo ctrl_break_vector, old_ctrl_break_vector;
static __dpmi_regs ctrl_break_regs;
#endif
static int ctrlbreakinstalled = 0;

#ifndef GO32WIN
/* Interrupt level detection of Ctrl-Break.  Don't do anything fancy here!  */

void
ctrl_break_func (regs)
     __dpmi_regs *regs;
{
  Vquit_flag = Qt;
}

static int ctrl_break_vector_tab [] =
{
  0x1b,				/* AT */
  0x06				/* PC98 */
};

/* patch 96.4.21  by K.Fujii */
void
reset_ctrl_break (void)
{
  _go32_dpmi_set_real_mode_interrupt_vector
    (ctrl_break_vector_tab [(__crt0_mtype >> 4) & 0x0f],
     &old_ctrl_break_vector);
  /* _go32_dpmi_free_real_mode_callback (&old_ctrl_break_vector); */
}
/* end of patch */
#endif /* ! GO32WIN */

void
install_ctrl_break_check ()
{
#ifndef GO32WIN
  __djgpp_set_ctrl_c (0);
#endif
  if (!ctrlbreakinstalled)
    {
#ifdef GO32WIN			/* Go32win Patch '95/02/26 by Y.Matsushima */
      go32win_install_ctrl_break_check(&Vquit_flag, &Qt, sizeof(Vquit_flag));
      ctrlbreakinstalled = 1;
#else
      /* Don't press Ctrl-Break if you don't have either DPMI or Emacs
	 was compiler with Djgpp 1.11 maintenance level 5 or later!  */
      {
	int vector = ctrl_break_vector_tab [(__crt0_mtype >> 4) & 0x0f];

	ctrlbreakinstalled = 1;
	_go32_dpmi_get_real_mode_interrupt_vector (vector,
						   &old_ctrl_break_vector);
	ctrl_break_vector.pm_offset = (int) ctrl_break_func;
	_go32_dpmi_allocate_real_mode_callback_iret (&ctrl_break_vector,
						     &ctrl_break_regs);
	_go32_dpmi_set_real_mode_interrupt_vector (vector,
						   &ctrl_break_vector);
	/* patch 96.4.21  by K.Fujii */
	atexit (reset_ctrl_break);
	/* end of patch */
      }
#endif /* GO32WIN */
    }
}

/*
 * Turn off Dos' Ctrl-C checking and inhibit interpretation of
 * control chars by Dos.
 * Determine the keyboard type.
 */

#ifndef GO32WIN
/* patch 94.7.9  by K.Fujii, 94.8.15  by T.Yasuda */
static unsigned char dos_keys_98[786];
static unsigned char emacs_keys_98 [] =
{
  /* Key label              key data */
  0376,' ','C','1',' ',' ', 0377, 1,0,0,0,0,0,0,0,0, /* f.1 */
  0376,' ','C','U',' ',' ', 0377, 2,0,0,0,0,0,0,0,0, /* f.2 */
  0376,' ','C','A',' ',' ', 0377, 3,0,0,0,0,0,0,0,0, /* f.3 */
  0376,' ','S','1',' ',' ', 0377, 4,0,0,0,0,0,0,0,0, /* f.4 */
  0376,' ','S','U',' ',' ', 0377, 5,0,0,0,0,0,0,0,0, /* f.5 */
  0376,'V','O','I','D',' ', 0377, 6,0,0,0,0,0,0,0,0, /* f.6 */
  0376,'N','W','L',' ',' ', 0377, 7,0,0,0,0,0,0,0,0, /* f.7 */
  0376,'I','N','S',' ',' ', 0377, 8,0,0,0,0,0,0,0,0, /* f.8 */
  0376,'R','E','P',' ',' ', 0377, 9,0,0,0,0,0,0,0,0, /* f.9 */
  0376,' ','^','Z',' ',' ', 0377,10,0,0,0,0,0,0,0,0, /* f.10 */
  0376,'d','i','r',' ','a', 0377,11,0,0,0,0,0,0,0,0, /* Sf.1 */
  0376,'d','i','r',' ','b', 0377,12,0,0,0,0,0,0,0,0, /* Sf.2 */
  0376,'c','o','p','y',' ', 0377,13,0,0,0,0,0,0,0,0, /* Sf.3 */
  0376,'d','e','l',' ',' ', 0377,14,0,0,0,0,0,0,0,0, /* Sf.4 */
  0376,'r','e','n',' ',' ', 0377,15,0,0,0,0,0,0,0,0, /* Sf.5 */
  0376,'c','h','k','d','s', 0377,16,0,0,0,0,0,0,0,0, /* Sf.6 */
  0376,'c','h','k','d','s', 0377,17,0,0,0,0,0,0,0,0, /* Sf.7 */
  0376,'t','y','p','e',' ', 0377,18,0,0,0,0,0,0,0,0, /* Sf.8 */
  0376,'d','a','t','e',' ', 0377,19,0,0,0,0,0,0,0,0, /* Sf.9 */
  0376,'t','i','m','e',' ', 0377,20,0,0,0,0,0,0,0,0, /* Sf.10 */
                            0377,21,0,0,0,0,         /* R-up */
                            0377,22,0,0,0,0,         /* R-down */
                            0377,23,0,0,0,0,         /* INS */
                            0377,24,0,0,0,0,         /* DEL */
                            0377,25,0,0,0,0,         /* up */
                            0377,26,0,0,0,0,         /* left */
                            0377,27,0,0,0,0,         /* right */
                            0377,28,0,0,0,0,         /* down */
                            0377,29,0,0,0,0,         /* HOME */
                            0377,30,0,0,0,0,         /* HELP */
                            0377,31,0,0,0,0,         /* CLR */
  0376,040,040,040,040,040, 0377,32,0,0,0,0,0,0,0,0, /* vf.1 */
  0376,040,040,040,040,040, 0377,33,0,0,0,0,0,0,0,0, /* vf.2 */
  0376,040,040,040,040,040, 0377,34,0,0,0,0,0,0,0,0, /* vf.3 */
  0376,040,040,040,040,040, 0377,35,0,0,0,0,0,0,0,0, /* vf.4 */
  0376,040,040,040,040,040, 0377,36,0,0,0,0,0,0,0,0, /* vf.5 */
  0376,040,040,040,040,040, 0377,37,0,0,0,0,0,0,0,0, /* Svf.1 */
  0376,040,040,040,040,040, 0377,38,0,0,0,0,0,0,0,0, /* Svf.2 */
  0376,040,040,040,040,040, 0377,39,0,0,0,0,0,0,0,0, /* Svf.3 */
  0376,040,040,040,040,040, 0377,40,0,0,0,0,0,0,0,0, /* Svf.4 */
  0376,040,040,040,040,040, 0377,41,0,0,0,0,0,0,0,0, /* Svf.5 */
  0376,040,040,040,040,040, 0377,42,0,0,0,0,0,0,0,0, /* Cf.1 */
  0376,040,040,040,040,040, 0377,43,0,0,0,0,0,0,0,0, /* Cf.2 */
  0376,040,040,040,040,040, 0377,44,0,0,0,0,0,0,0,0, /* Cf.3 */
  0376,040,040,040,040,040, 0377,45,0,0,0,0,0,0,0,0, /* Cf.4 */
  0376,040,040,040,040,040, 0377,46,0,0,0,0,0,0,0,0, /* Cf.5 */
  0376,040,040,040,040,040, 0377,47,0,0,0,0,0,0,0,0, /* Cf.6 */
  0376,040,040,040,040,040, 0377,48,0,0,0,0,0,0,0,0, /* Cf.7 */
  0376,040,040,040,040,040, 0377,49,0,0,0,0,0,0,0,0, /* Cf.8 */
  0376,040,040,040,040,040, 0377,50,0,0,0,0,0,0,0,0, /* Cf.9 */
  0376,040,040,040,040,040, 0377,51,0,0,0,0,0,0,0,0, /* Cf.10 */
  0376,040,040,040,040,040, 0377,52,0,0,0,0,0,0,0,0, /* Cvf.1 */
  0376,040,040,040,040,040, 0377,53,0,0,0,0,0,0,0,0, /* Cvf.2 */
  0376,040,040,040,040,040, 0377,54,0,0,0,0,0,0,0,0, /* Cvf.3 */
  0376,040,040,040,040,040, 0377,55,0,0,0,0,0,0,0,0, /* Cvf.4 */
  0376,040,040,040,040,040, 0377,56,0,0,0,0,0,0,0,0, /* Cvf.5 */
};
#endif

/* end of patch */

int
dos_ttraw ()
{
#ifdef GO32WIN
  union REGS regs;
#else
  __dpmi_regs regs;
  _go32_dpmi_seginfo info;
#endif
  static int first_time = 1;
  
  break_stat = getcbrk ();
  setcbrk (0);
  install_ctrl_break_check ();

#ifndef GO32WIN
  if (MachinePc98 ()) /* PC-98*1 */
    {
      regs.h.cl = 0x0f;
      regs.x.ax = 0;
      __dpmi_int (0xdc, &regs);
      _go32_dpmi_rm_size (info, sizeof (dos_keys_98));
      if (_go32_dpmi_allocate_dos_memory (&info))
	abort ();
    }
#endif

  if (first_time)
    {
#ifdef GO32WIN /* Go32win Patch '95/02/06 by Y.Matsushime, 95.11.13, 96.1.21 by K.Fujii */
      /* extend_kbd = 1; */
#else
      if (MachinePc98 ())
	{
	  regs.h.cl = 0x0c;
	  regs.x.ax = 0x0000;
	  regs.x.dx = _go32_dpmi_rm_offset (info);
	  regs.x.ds = _go32_dpmi_rm_segment (info);
	  __dpmi_int (0xdc, &regs);
	  dosmemget ((int)_go32_dpmi_work_offset (info),
		     sizeof (dos_keys_98),
		     dos_keys_98);
	}
      else
	{
	  regs.h.ah = 0xc0;
	  __dpmi_int (0x15, &regs);
	  extend_kbd = (!(regs.x.flags & 1)) && (regs.h.ah == 0);
	}
#endif
      have_mouse = 0;

#ifndef GO32WIN
      if (internal_terminal
#ifdef HAVE_X_WINDOWS
	  && inhibit_window_system
#endif
	  )
	{
	  regs.x.ax = 0x0021;
	  __dpmi_int (0x33, &regs);
	  have_mouse = (regs.x.ax & 0xffff) == 0xffff;
	  if (!have_mouse)
	    {
	      /* Reportedly, the above doesn't work for some mouse drivers.  There
		 is an additional detection method that should work, but might be
		 a little slower.  Use that as an alternative.  */
	      regs.x.ax = 0x0000;
	      __dpmi_int (0x33, &regs);
	      have_mouse = (regs.x.ax & 0xffff) == 0xffff;
	    }

	  if (have_mouse)
	    {
	      have_mouse = 1;	/* enable mouse */
	      mouse_visible = 0;

	      if (regs.x.bx == 3)
		{
		  mouse_button_count = 3;
		  mouse_button_translate[0] = 0; /* Left */
		  mouse_button_translate[1] = 2; /* Middle */
		  mouse_button_translate[2] = 1; /* Right */
		}
	      else
		{
		  mouse_button_count = 2;
		  mouse_button_translate[0] = 0;
		  mouse_button_translate[1] = 1;
		}
	      mouse_position_hook = &mouse_get_pos;
	      mouse_init ();
	    }
	}
#endif

      first_time = 0;
    }

#ifndef GO32WIN
  if (MachinePc98 ())
    {
      dosmemput (emacs_keys_98,
		 sizeof (emacs_keys_98),
		 _go32_dpmi_work_offset (info));
      regs.h.cl = 0x0d;
      regs.x.ax = 0x0000;
      regs.x.dx = _go32_dpmi_rm_offset (info);
      regs.x.ds = _go32_dpmi_rm_segment (info);
      __dpmi_int (0xdc, &regs);
      _go32_dpmi_free_dos_memory (&info);
    }
  else if (ModeDOSV ())	/* 96.10.31, 96.1.21  by K.Fujii */
    {
      regs.h.ah = 0x01;
      regs.x.cx = 0x0407;
      __dpmi_int (0x10, &regs);
    }
#endif

  regs.x.ax = 0x4400;		/* Get IOCTL status. */
  regs.x.bx = 0x00;		/* 0 = stdin. */
#ifdef GO32WIN
  intdos (&regs, &regs);
#else
  __dpmi_int (0x21, &regs);
#endif
  stdin_stat = regs.h.dl;

  regs.h.dl = stdin_stat | 0x0020; /* raw mode */
  regs.h.dh = 0;
  regs.x.ax = 0x4401;		/* Set IOCTL status */
#ifdef GO32WIN
  intdos (&regs, &regs);
  return !regs.x.cflag;
#else
  __dpmi_int (0x21, &regs);
  return !(regs.x.flags & 1);
#endif
}

/*  Restore status of standard input and Ctrl-C checking.  */
int
dos_ttcooked ()
{
#ifdef GO32WIN
  union REGS regs;
#else
  __dpmi_regs regs;
  _go32_dpmi_seginfo info;
#endif

#ifndef GO32WIN /* 95.3.30, 95.10.31  by K.Fujii */
  if (ModeDOSV ()) /* DOS/V jp */
    {
      regs.h.ah = 0x01;
      regs.x.cx = 0x0607;	/* underline cursoru */
      __dpmi_int (0x10, &regs);
    }

  if (MachinePc98 ()) /* PC-98*1 94.8.15  by T.Yasuda, 95.2.11 by K.Fujii */
    { /* 94.7.9  by K.Fujii */
      _go32_dpmi_rm_size (info, sizeof (dos_keys_98));
      _go32_dpmi_allocate_dos_memory (&info);
      dosmemput (dos_keys_98, sizeof(dos_keys_98), _go32_dpmi_work_offset (info));
      regs.h.cl = 0x0d;
      regs.x.ax = 0x0000;
      regs.x.dx = _go32_dpmi_rm_offset (info);
      regs.x.ds = _go32_dpmi_rm_segment (info);
      __dpmi_int (0xdc, &regs);
      _go32_dpmi_free_dos_memory (&info);
      regs.h.cl = 0x0f;
      regs.x.ax = 1;
      __dpmi_int (0xdc, &regs);
    }
#endif

  setcbrk (break_stat);
#ifndef GO32WIN
  mouse_off ();
#endif

  regs.x.ax = 0x4401;	/* Set IOCTL status.	*/
  regs.x.bx = 0x00;	/* 0 = stdin.		*/
  regs.h.dl = stdin_stat;
  regs.h.dh = 0;
#ifdef GO32WIN
  intdos (&regs, &regs);
  return ! regs.x.cflag;
#else
  __dpmi_int (0x21, &regs);
  return !(regs.x.flags & 1);
#endif
}


/* Run command as specified by ARGV in directory DIR.
   The command is run with input from TEMPIN and output to file TEMPOUT.  */
int
run_msdos_command (argv, dir, tempin, tempout)
     unsigned char **argv;
     Lisp_Object dir;
     int tempin, tempout;
{
  char *saveargv1, *saveargv2, **envv;
  char oldwd[MAXPATHLEN + 1]; /* Fixed size is safe on MSDOS.  */
  /* patch 94.9.19  by K.Fujii */
  char oldcwd[MAXPATHLEN + 1];
  int old_drv = -1, new_drv = -1;
  /* end of patch */
  int msshell, result = -1;
  int in, out, inbak, outbak, errbak;
  int x, y;
  Lisp_Object cmd;

  /* Get current directory as MSDOS cwd is not per-process.  */
  getwd (oldwd);

#if 0 /* patch 96.12.12  by K.Fujii. */
  cmd = Ffile_name_nondirectory (build_string (argv[0]));
  msshell = !NILP (Fmember (cmd, Fsymbol_value (intern ("msdos-shells"))))
   /* && !strcmp ("-c", argv[1]) */; /* K.Fujii */
#else
  {
    Lisp_Object shells;

    cmd = Ffile_name_nondirectory (build_string (argv [0]));
    msshell = 0;
    for (shells = Fsymbol_value (intern ("msdos-shells"));
	 ! NILP (shells); shells = XCONS (shells)->cdr) {
      if (STRINGP (XCONS (shells)->car) &&
	  XSTRING (cmd)->size == XSTRING (XCONS (shells)->car)->size &&
	  stricmp (XSTRING (cmd)->data,
		   XSTRING (XCONS (shells)->car)->data) == 0) {
	msshell = 1;
	break;
      }
    }
  }
#endif
  if (msshell)
    {
      char *shell_error_msg = (char *) 0;

      if (! argv[1])
	shell_error_msg = "not given command";
      else
	{
	  if (! argv [2]) shell_error_msg = "not given command";
	  else
	    {
	      unsigned char *ap = argv[1];

	      while (*ap && (*ap == ' ' || *ap == '\t')) ap++;
	      if ((ap[0] == '/' || ap[0] == '-') &&
		  ap[1] == 'c' && (! ap[2] || ap[2] == ' ' || ap[2] == '\t'))
		;
	      else
		shell_error_msg = "lost `/c\' or `-c\'";
	    }
	}
      if (shell_error_msg)
	error ("Sub-Shell(%s) : %s !!", XSTRING (cmd)->data, shell_error_msg);

      saveargv1 = argv[1];
      saveargv2 = argv[2];
      argv[1] = "/c";
      if (argv[2])
	{
	  char *p = alloca (strlen (argv[2]) + 1);

	  strcpy (argv[2] = p, saveargv2);
	  while (*p && isspace (*p))
	    p++;
	  while (*p && !isspace (*p))
	    if (*p == '/')
	      *p++ = '\\';
	    else
	      p++;
	}
    }

  /* Build the environment array.  */
#if 1 /* 95.7.24, 95.9.25 by K.Fujii */
  envv = environ;
#else
#ifdef GO32WIN			/* Go32win Patch '95/02/26 by Y.Matsushima */
  if( !_go32_windows )
#endif
  {
    extern Lisp_Object Vprocess_environment;
    Lisp_Object tmp, lst;
    int i, len;

    lst = Vprocess_environment;
    len = XFASTINT (Flength (lst));

    envv = alloca ((len + 1) * sizeof (char *));
    for (i = 0; i < len; i++)
      {
	tmp = Fcar (lst);
	lst = Fcdr (lst);
	CHECK_STRING (tmp, 0);
	envv[i] = alloca (XSTRING (tmp)->size + 1);
	strcpy (envv[i], XSTRING (tmp)->data);
      }
    envv[len] = (char *) 0;
  }
#endif

  if (STRINGP (dir))
  /* patch 94.9.19  by K.Fujii */
    {
      old_drv = getdisk ();
      if (XSTRING (dir)->data [1] == ':' &&
	  old_drv != (tolower (XSTRING (dir)->data [0]) - 'a'))
	{
	  new_drv = tolower (XSTRING (dir)->data [0]) - 'a';
	  setdisk (new_drv);
	  getwd (oldcwd);
	  setdisk (old_drv);
	}
  /* end of patch */
      chdir (XSTRING (dir)->data);
    }

#ifndef GO32WIN
  if (have_mouse > 0)
    mouse_get_xy (&x, &y);
#endif

  dos_ttcooked ();		/* 94.11.12  by K.Fujii */

  inbak = dup (0);
  outbak = dup (1);
  errbak = dup (2);
  if (inbak < 0 || outbak < 0 || errbak < 0)
    goto done; /* Allocation might fail due to lack of descriptors.  */

  dup2 (tempin, 0);
  dup2 (tempout, 1);
  dup2 (tempout, 2);

#ifdef GO32WIN			/* Go32win Patch '95/02/26 by Y.Matsushima */
  {
    char com[256];
    int i;
    com[0] = 0;
    for( i = 0; argv[i]; i++ )
      strcat(strcat(com, argv[i]), " ");
    result = !system(com);
  }
#else
  result = spawnve (P_WAIT, argv[0], argv, envv);
#endif

  dup2 (inbak, 0);
  dup2 (outbak, 1);
  dup2 (errbak, 2);
  close (inbak);
  close (outbak);
  close (errbak);

 done:				/* 962.12 by K.Fujii */
  dos_ttraw ();
#ifndef GO32WIN
  if (have_mouse > 0)
    {
      mouse_init ();
      mouse_moveto (x, y);
    }
#endif
  
  /* patch 94.9.19  by K.Fuji */
  if (new_drv != -1)
    chdir (oldcwd);
  /* end of patch */
  chdir (oldwd);
  if (msshell)
    {
      argv[1] = saveargv1;
      argv[2] = saveargv2;
    }
  return result;
}

croak (badfunc)
     char *badfunc;
{
  fprintf (stderr, "%s not yet implemented\r\n", badfunc);
  reset_sys_modes ();
  exit (1);
}


/* ------------------------- Compatibility functions -------------------
 *	gethostname
 *	gettimeofday
 */

/*
 * Hostnames for a pc are not really funny,
 * but they are used in change log so we emulate the best we can.
 */

gethostname (p, size)
     char *p;
     int size;
{
  char *q = egetenv ("HOSTNAME");

  if (!q) q = "pc";
  strcpy (p, q);
  return 0;
}

/* When time zones are set from Ms-Dos too many C-libraries are playing
   tricks with time values.  We solve this by defining our own version
   of `gettimeofday' bypassing GO32.  Our version needs to be initialized
   once and after each call to `tzset' with TZ changed.  That is 
   accomplished by aliasing tzset to init_gettimeofday. */

static struct tm time_rec;

int
gettimeofday (struct timeval *tp, struct timezone *tzp)
{
  if (tp)
    {
      struct time t;
      struct tm tm;

      gettime (&t);
      if (t.ti_hour < time_rec.tm_hour) /* midnight wrap */
	{
	  struct date d;
	  getdate (&d);
	  time_rec.tm_year = d.da_year - 1900;
	  time_rec.tm_mon = d.da_mon - 1;
	  time_rec.tm_mday = d.da_day;
	}
      
      time_rec.tm_hour = t.ti_hour;
      time_rec.tm_min = t.ti_min;
      time_rec.tm_sec = t.ti_sec;

      tm = time_rec;
      tm.tm_gmtoff = dos_timezone_offset;

      tp->tv_sec = mktime (&tm);	/* may modify tm */
      tp->tv_usec = t.ti_hund * (1000000 / 100);
    }
  /* Ignore tzp; it's obsolescent.  */
  return 0;
}


/*
 * A list of unimplemented functions that we silently ignore.
 */

unsigned alarm (s) unsigned s; {}
fork () { return 0; }
int kill (x, y) int x, y; { return -1; }
nice (p) int p; {}
void volatile pause () {}
request_sigio () {}
setpgrp () {return 0; }
setpriority (x,y,z) int x,y,z; { return 0; }
sigsetmask (x) int x; { return 0; }
unrequest_sigio () {}

int run_dos_timer_hooks = 0;

#ifndef HAVE_SELECT
/* #include "sysselect.h" */ /* 96.2.12  by K.Fujii */

#ifndef GO32WIN
static int last_ti_sec = -1;
static int dos_menubar_clock_displayed = 0;

static void
check_timer (t)
  struct time *t;
{
  /* patch 96.4.23  by K.Fujii */
  extern Lisp_Object Vdos_menubar_clock_color;
  extern Lisp_Object Fmsdos_color_translate (Lisp_Object);
  /* end of patch */

  gettime (t);
  
  if (t->ti_sec == last_ti_sec)
    return;
  last_ti_sec = t->ti_sec;

  if (!NILP (Vdos_menubar_clock))
    {
      unsigned color;		/* 96.4.23  by K.Fujii */
      char clock_str[16];
      int len;
      int min = t->ti_min;
      int hour = t->ti_hour;

#if 0  /* 96.2.10  by K.Fujii */
      if (dos_timezone_offset)
	{
	  int tz = dos_timezone_offset;
	  min -= tz % 60;
	  if (min < 0)
	    min += 60, hour--;
	  else
	    if (min >= 60)
	      min -= 60, hour++;
	  
	  if ((hour -= (tz / 60)) < 0)
	    hour += 24;
	  else
	    hour %= 24;
	}
#endif

      if ((dos_country_info[0x11] & 0x01) == 0) /* 12 hour clock */
	{
	  hour %= 12;
	  if (hour == 0) hour = 12;
	}

      /* patch 96.4.23  by K.Fujii */
      if (CONSP (Vdos_menubar_clock_color)) {
	Lisp_Object fore, back;

	fore = Fmsdos_color_translate (Fcar (Vdos_menubar_clock_color));
	back = Fmsdos_color_translate (Fcdr (Vdos_menubar_clock_color));
	if (MachinePc98 ()) {
	  if (! NILP (back) &&
	      XINT (back) != FACE_COLOR_BLACK) {
	    color = Color_98[XINT (back)];
	    color |= 4;
	  }
	  else
	    color = Color_98 [XINT (fore)];
	}
	else {
	  color = (NILP (fore) ? ScreenAttrib : XINT (fore)) & 0x0f;
	  color |= (NILP (back) ? ScreenAttrib : (XINT (back) << 4)) & 0xf0;
	}
      }
      else
	color = ScreenAttrib;

      len = sprintf (clock_str, "%2d:%02d:%02d", hour, min, t->ti_sec);
      ScreenOutputString (screen_size_X - len - 1, 0, clock_str, len, color);
      /* end of patch */
      /*      dos_direct_output (0, screen_size_X - len - 1, clock_str, len); */
      dos_menubar_clock_displayed = 1;
    }
  else if (dos_menubar_clock_displayed)
    {
      /* Erase last displayed time.  */
      dos_direct_output (0, screen_size_X - 9, "        ", 8);
      dos_menubar_clock_displayed = 0;
    }
  
  if (!NILP (Vdos_timer_hooks))
    run_dos_timer_hooks++;
}

/* Only event queue is checked.  */

#if 0
static int safety_level_time_count_pc98 = -1;
static int clock_98_counter = -1;
static __dpmi_regs timer_func_vector_98_regs;
static _go32_dpmi_seginfo old_vector_08, new_vector_08;
static int timer_98_installed = 0;

void
timer_count_func_98 (__dpmi_regs *regs)
{
  clock_98_counter++;
  asm volatile
    ("	movb	$0x20, %%al
	outb	%%al, $0x00"
     : /* not output */
     : /* not input */
     : "%eax");
}

void
reset_timer_98 (void)
{
  if (timer_98_installed && MachinePc98 ()) {
    asm volatile
      ("	inb	$0x02, %%al
		orb	$1, %%al
		outb	%%al, $0x02"
       : /* not output */
       : /* not input */
       : "%eax");
    _go32_dpmi_set_real_mode_interrupt_vector (0x08, &old_vector_08);
    /*    _go32_dpmi_free_real_mode_callback (&old_vector_08); */
  }
}

void
set_timer_98 (void)
{
  unsigned char bios_flag;
  int cc;

  if (! timer_98_installed && MachinePc98 ()) {
    timer_98_installed = 1;
    clock_98_counter = 0;
    _go32_dpmi_get_real_mode_interrupt_vector (8, &old_vector_08);
    new_vector_08.pm_offset = (int) timer_count_func_98;
    _go32_dpmi_allocate_real_mode_callback_iret (&new_vector_08,
						 &timer_func_vector_98_regs);
    _go32_dpmi_set_real_mode_interrupt_vector (8, &new_vector_08);
    dosmemget (0x501, 1, &bios_flag);
    cc = ((bios_flag & 0x80) ? 0x4e00 : 0x6000) * 2;
    asm volatile
      ("	movb	$0x36, %%al
		outb	%%al, $0x77
		jmp	1f
1:		jmp	1f
1:		movb	%%cl, %%al
		outb	%%al, $0x71
		jmp	1f
1:		jmp	1f
1:		movb	%%ch, %%al
		outb	%%al, $0x71
		inb	$0x02, %%al
		andb	$0xfe, %%al
		outb	%%al, $0x02"
       : /* not output */
       : "c" (cc)
       : "%eax");
    atexit (reset_timer_98);
  }
}

static int clock_bss = -1;

clock_t
clock (void)
{
  static unsigned long last_tics = -1;
  static clock_t base = -1;
  unsigned long tics, otics;
  clock_t rv;
  int scale;

  if (clock_bss != __bss_count)
  {
    clock_bss = __bss_count;
    last_tics = 0;
    base = 0;
  }

  if (MachinePc98 ()) {
    scale = 20000;
    if (timer_98_installed) {
      do {
	otics = clock_98_counter;
	tics = clock_98_counter;
      } while (otics != tics);
    }
    else {
      do {
	otics = _farpeekl (_dos_ds, 0x560);
	tics = _farpeekl (_dos_ds, 0x560);
      } while (tics != otics);
    }
  }
  else {
    scale = 50000;
    do {
      otics = _farpeekl (_dos_ds, 0x46c);
      tics = _farpeekl (_dos_ds, 0x46c);
    } while (otics != tics);
  }

  rv = (clock_t) tics;

  if (! base) base = rv;

  if (! MachinePc98 () && last_tics > tics)
    base -= 0x1800b0;

  last_tics = tics;

  return (rv - base) * scale;
}

DEFUN ("timer-safety-level-pc98", Ftimer_safety_level_pc98,
       Stimer_safety_level_pc98, 1, 1, 0,
  "Set timer counting safety level on PC98.\n\
\n\
LEVEL is\n\
  'cwsdpmi\n\
  'timer      = used CWSDPMI-servers timer. A little risky it.\n\
\n\
  'timer-hook\n\
  'tdpmi\n\
  'hook       = used timer interrupt hooked. But can not use\n\
                some DPMI-servor other TDPMI.\n\
\n\
   other      = used 'gettime'. This is allround safty.\n\
                But ti_hound is evry time zero on PC98.")
  (level)
     Lisp_Object level;
{
  if (MachinePc98 ()) {
    /* check installed CWSDPMI(support timer) */
    int i;
    unsigned long t = _farpeekl (_dos_ds, 0x560);

    for (i = 100; i > 0; i--) {
      if (t > _farpeekl (_dos_ds, 0x560)) {
	if (EQ (level, intern ("cwsdpmi")) ||
	    EQ (level, intern ("timer")) ||
	    EQ (level, intern ("tdpmi")) ||
	    EQ (level, intern ("hook")) ||
	    EQ (level, intern ("timer-hook")))
	  safety_level_time_count_pc98 = 1;
	else
	  safety_level_time_count_pc98 = 0;
	return Qnil;
      }
    }

    if (EQ (level, intern ("tdpmi")) ||
	EQ (level, intern ("hook")) ||
	EQ (level, intern ("timer-hook"))) {
      if (! timer_98_installed) {
	set_timer_98 ();
      }
      safety_level_time_count_pc98 = 2;
    }
    else
      safety_level_time_count_pc98 = 0;
  }
  return Qnil;
}
#endif /* 0 */
#endif /* ! GO32WIN */

int
sys_select (nfds, rfds, wfds, efds, timeout)
     int nfds;
     SELECT_TYPE *rfds, *wfds, *efds;
     EMACS_TIME *timeout;
{
  int check_input;
  long timeoutval, clnow, cllast;
  struct time t;

  check_input = 0;
  if (rfds)
    {
      check_input = FD_ISSET (0, rfds);
      FD_ZERO (rfds);
    }
  if (wfds)
    FD_ZERO (wfds);
  if (efds)
    FD_ZERO (efds);

  if (nfds != 1)
    abort ();
  
  /* If we are looking only for the terminal, with no timeout,
     just read it and wait -- that's more efficient.  */
  if (!timeout)
    {
      while (! detect_input_pending ())
#ifndef GO32WIN
	check_timer (&t)
#endif
	  ;
    }
  else
    {
#if 0
      /* patch 95.11.12, 95.12.8, 96.1.21  by K.Fujii */
      if (MachinePc98 ()
#ifndef GO32WIN
	  && safety_level_time_count_pc98 >= 1
#endif
	  )
	{
	  long clocks_per_sec =
#ifdef GO32WIN
	    10
#else
	    10000
#endif
	    ;

	  clnow = (unsigned long) clock ();
	  timeoutval =
	    clnow + (((EMACS_SECS  (*timeout) * 100)
		      + (EMACS_USECS (*timeout) / 10000))
		     * clocks_per_sec);

	  while (! check_input || ! detect_input_pending ())
	    {
#ifndef GO32WIN
	      check_timer (&t);
#endif
	      clnow = (unsigned long) clock ();
	      if (clnow >= timeoutval)
		return 0;
	    }
	}
      else
#endif /* 0 */
	{
	  /* end of patch */
	  timeoutval = EMACS_SECS (*timeout) * 100 + EMACS_USECS (*timeout) / 10000;
#ifdef GO32WIN
	  gettime (&t);
#else
	  check_timer (&t);
#endif
	  cllast = t.ti_sec * 100 + t.ti_hund;

	  while (!check_input || !detect_input_pending ())
	    {
#ifdef GO32WIN
	      gettime (&t);
#else
	      check_timer (&t);
#endif
	      clnow = t.ti_sec * 100 + t.ti_hund;
	      if (clnow < cllast) /* time wrap */
		timeoutval -= clnow + 6000 - cllast;
	      else
		timeoutval -= clnow - cllast;
	      if (timeoutval <= 0)  /* Stop on timer being cleared */
		return 0;
	      cllast = clnow;
	    }
	}
    }
  
  FD_SET (0, rfds);
  return 1;
}
#endif /* ! HAVE_SELECT */

/*
 * Define overlayed functions:
 *
 *	chdir -> sys_chdir
 *	tzset -> init_gettimeofday
 *	abort -> dos_abort
 */

#if ! defined (MCPATH) && defined (chdir)
#undef chdir

extern int chdir ();

int
sys_chdir (path)
     const char* path;
{
  int len = strlen (path);
  char *tmp = (char *)path;

  if (*tmp && tmp[1] == ':')
    {
      if (getdisk () != tolower (tmp[0]) - 'a')
	setdisk (tolower (tmp[0]) - 'a');
      tmp += 2;	/* strip drive: KFS 1995-07-06 */
      len -= 2;
    }
  
  if (len > 1 && (tmp[len - 1] == '/'))
    {
      char *tmp1 = (char *) alloca (len + 1);
      strcpy (tmp1, tmp);
      tmp1[len - 1] = 0;
      tmp = tmp1;
    }
  return chdir (tmp);
}
#endif

#ifdef tzset
#undef tzset
extern void tzset (void);

void
init_gettimeofday ()
{
  time_t ltm, gtm;
  struct tm *lstm;

  tzset ();
  ltm = gtm = time (NULL);
  ltm = mktime (lstm = localtime (&ltm));
  gtm = mktime (gmtime (&gtm));
  time_rec.tm_hour = 99;	/* force gettimeofday to get date */
  time_rec.tm_isdst = lstm->tm_isdst;
  dos_timezone_offset = time_rec.tm_gmtoff = (int)(gtm - ltm) / 60;
}
#endif

#ifndef GO32WIN /* patch 96.4.3  by K.Fujii */
short __dpmi_int_real_mode_stack_size = 1024;
#endif /* ! GO32WIN */

#ifdef abort
#undef abort

void
dos_abort (file, line)
     char *file;
     int  line;
{
  char buffer1[200];
  int i, j;

  sprintf (buffer1, "<EMACS FATAL ERROR IN %s LINE %d>", file, line);
  /* patch 96.1.21  by K.Fujii */
  i = strlen (buffer1);
  ScreenOutputString (0, 0, buffer1, i,
		      (MachinePc98 () ? 0x44 : 0xcf));
  /* end of patch */
  ScreenSetCursor (2, 0);

  abort ();
}
#endif

#ifndef GO32WIN
/* patch 95.11.18, 95.12.2  by K.Fujii */
void
init_msdos (void)
{
  ScreenInit (MachinePc98 () ? 0xe0 : 7, 1);

  if (MachinePc98 ()) /* PC-98*1 */
    {
      dos_rawgetc_fun = dos_rawgetc_98;
      dos_get_modifiers_fun = dos_get_modifiers_98;
    }
  else				/* DOS/V */
    {
      dos_rawgetc_fun = dos_rawgetc_at;
      dos_get_modifiers_fun = dos_get_modifiers_at;
    }
}

void
terminate_msdos (void)
{
  extern void ScreenTerminate (void);

  ScreenTerminate ();
}
/* end of patch */

syms_of_msdos ()
{
  recent_doskeys = Fmake_vector (make_number (NUM_RECENT_DOSKEYS), Qnil);
  staticpro (&recent_doskeys);

  defsubr (&Srecent_doskeys);
  /* patch 95.3.26, 95.12.5, 96.2.21, 96.4.22  by K.Fujii */
  defsubr (&Sinternal_terminal_p);
#if 0
  defsubr (&Stimer_safety_level_pc98);
#endif
  /* end of patch */

  DEFVAR_BOOL ("print-ascii-in-jis", &print_ascii_in_jis,
    "*");
  print_ascii_in_jis = 0;
}
#endif /* not GO32WIN */

  
#endif /* MSDOS */
