/* Copyright (C) 1991 Free Software Foundation, Inc.
This file is part of the GNU C Library.

The GNU C Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The GNU C Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with the GNU C Library; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.  */

/*  Modified for Shift-JIS Code by Y.Shibata(FATMAN)  1992 Jun 6th  */

#if 0
#include <ansidecl.h>
#endif
#include <ctype.h>
#include <stddef.h>
#include <stdlib.h>
#include <jctype.h>

#if 0
extern int _mb_shift;	/* Defined in mbtowc.c.  */
#endif

/* Convert the string of multibyte characters in S to `wchar_t's in
   PWCS, writing no more than N.  Return the number written,
   or (size_t) -1 if an invalid multibyte character is encountered.  */

size_t	mbstowcs (register wchar_t *pwcs ,register const char *s 
		 ,register size_t n)
{
  register size_t written = 0;
  int	   len = 0;

  while (*s != '\0')
    {
    len = mbtowc(pwcs, s, n);
    if (len < 0)
      return (size_t)-1;
    if (len == 0)
      break;

/* Multibyte character converted.  */
      ++pwcs;
      ++written;
      s += len;
      n -= len;
    }

  /* Terminate the string if it has space.  */
  if (n > 0)
    *pwcs = (wchar_t) 0;
#if 0
  /* Restore the old shift state.  */
  _mb_shift = save_shift;
#endif
  /* Return how many we wrote (or maybe an error).  */
  return written;
}
