/* Copyright (C) 1991 Free Software Foundation, Inc.
This file is part of the GNU C Library.

The GNU C Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The GNU C Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with the GNU C Library; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.  */

/*  Modified for Shift-JIS Code by Y.Shibata(FATMAN)  1992 Jun 6th  */

#if 0
#include <ansidecl.h>
#include <localeinfo.h>
#endif
#include <ctype.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <jctype.h>

/* Convert the `wchar_t' string in PWCS to a multibyte character string
   in S, writing no more than N characters.  Return the number of bytes
   written, or (size_t) -1 if an invalid `wchar_t' was found.  */

size_t	wcstombs (register char *s , register const wchar_t *pwcs ,
		  register size_t n)
{
  register size_t written = 0;
  register wchar_t w;
  int	   len;
  char	   work[2];

  while ((w = *pwcs++) != (wchar_t) '\0')
    {
      if (w == ((wchar_t) EOF))
	return (size_t) -1;

      len = wctomb(work,w);
      if (len < 0)
	return (size_t) -1;	/*  Invalid WideChar  */
      if (n < len)
	break;
      if (len == 2)
	{
	*s++ = work[0];
	*s++ = work[1];
	}
      else
	*s++ = work[0];

      written += len;
      n       -= len;
      if (n == 0)
	break;
    }

  /* Terminate the string if it has space.  */
  if (n > 0)
    *s = '\0';

  /* Return the number of characters written (or maybe an error).  */
  return written;
}
