/* Copyright (C) 1991 Free Software Foundation, Inc.
This file is part of the GNU C Library.

The GNU C Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The GNU C Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with the GNU C Library; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.  */

/*  Modified for Shift-JIS Code by Y.Shibata(FATMAN)  1992 Jun 6th  */

#if 0
#include <ansidecl.h>
#include <localeinfo.h>
#endif
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <jctype.h>

#if 0
extern int _mb_shift;	/* Defined in mbtowc.c.  */
#endif

/* Convert WCHAR into its multibyte character representation,
   putting this in S and returning its length.  */
int	wctomb (register char *s , wchar_t wchar)
{
  unsigned int hi,lo;

  if ((s == NULL)||(wchar == (wchar_t)'\0'))
    return 0;		/*  Not convert Multibyte string  */
  if (wchar & 0xffff0000)
    return -1;		/*  Invalid!! Shift-JIS Width = 2Byte  */

  hi = wchar >> 8;
  lo = wchar & 0xff;
  if (iskanji(hi) && iskanji2(lo))
    {
    *s++ = hi;
    *s   = lo;
    return 2;		/*  Return Shift-JIS Width  */
    }
  if ((hi == 0) && !iskanji(lo))
    {
    *s   = lo;
    return 1;		/*  Return ANK Char Width  */
    }

  return -1;		/*  Invalid!! Shift-JIS Code  */
}
